import { X as t, af as C, de as z, F as i, a6 as R, df as k, dh as m, dg as l, dn as v, at as H, dm as b } from "./27705007.js";
import { useContext as O } from "react";
import "react-dom";
const p = (o) => H`
    border-color: ${o.border};
    border-width: ${o.borderWidth};
    border-radius: ${o.radius};
    overflow: hidden;
    padding: ${o.padding};
    ${o.background && `background-color: ${o.background};`}
    ${o.backgroundImage && `background-image: ${o.backgroundImage};`}
    ${o.backgroundImageRepeat && `background-repeat: ${o.backgroundImageRepeat};`}
    ${o.backgroundImageSize && `background-size: ${o.backgroundImageSize};`}
    ${o.backgroundImagePosition && `background-position: ${o.backgroundImagePosition};`}
    ${o.backgroundImageOrigin && `background-origin: ${o.backgroundImageOrigin};`}
  `, W = t.div`
  display: flex;
  flex-flow: column;
  height: 100%;
  border: 1px solid #d7d9e0;
  border-radius: 4px;
  ${(o) => o.$style && p(o.$style)}
`, F = t(b)`
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$headerBackgroundImage && `background-image: ${o.$headerBackgroundImage};`}
  ${(o) => o.$headerBackgroundImageRepeat && `background-repeat: ${o.$headerBackgroundImageRepeat};`}
  ${(o) => o.$headerBackgroundImageSize && `background-size: ${o.$headerBackgroundImageSize};`}
  ${(o) => o.$headerBackgroundImagePosition && `background-position: ${o.$headerBackgroundImagePosition};`}
  ${(o) => o.$headerBackgroundImageOrigin && `background-origin: ${o.$headerBackgroundImageOrigin};`}
`, G = t(b)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  flex: 1;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$backgroundImage && `background-image: ${o.$backgroundImage};`}
  ${(o) => o.$backgroundImageRepeat && `background-repeat: ${o.$backgroundImageRepeat};`}
  ${(o) => o.$backgroundImageSize && `background-size: ${o.$backgroundImageSize};`}
  ${(o) => o.$backgroundImagePosition && `background-position: ${o.$backgroundImagePosition};`}
  ${(o) => o.$backgroundImageOrigin && `background-origin: ${o.$backgroundImageOrigin};`}
`, M = t(b)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$footerBackgroundImage && `background-image: ${o.$footerBackgroundImage};`}
  ${(o) => o.$footerBackgroundImageRepeat && `background-repeat: ${o.$footerBackgroundImageRepeat};`}
  ${(o) => o.$footerBackgroundImageSize && `background-size: ${o.$footerBackgroundImageSize};`}
  ${(o) => o.$footerBackgroundImagePosition && `background-position: ${o.$footerBackgroundImagePosition};`}
  ${(o) => o.$footerBackgroundImageOrigin && `background-origin: ${o.$footerBackgroundImageOrigin};`}
`;
function V(o) {
  const {
    container: g
  } = o, {
    showHeader: n,
    showFooter: $
  } = g, c = g.showBody || !n && !$, I = g.scrollbars, {
    items: h,
    ...s
  } = g.header, {
    items: B,
    ...P
  } = g.body[0].children.view.getView(), {
    items: f,
    ...w
  } = g.footer, {
    style: d,
    headerStyle: r,
    bodyStyle: a,
    footerStyle: e
  } = g, x = O(C).getAppSettings().maxWidth, u = z(x) ? 8 : 0;
  return /* @__PURE__ */ i("div", {
    style: {
      padding: d.margin,
      height: "100%"
    },
    children: /* @__PURE__ */ R(W, {
      $style: d,
      children: [n && /* @__PURE__ */ i(k.Provider, {
        value: r.headerBackground,
        children: /* @__PURE__ */ i(F, {
          ...s,
          items: m(h),
          autoHeight: !0,
          emptyRows: 5,
          minHeight: "46px",
          containerPadding: [u, 3],
          showName: {
            bottom: c || $ ? 20 : 0
          },
          $backgroundColor: (r == null ? void 0 : r.headerBackground) || "transparent",
          $headerBackgroundImage: r == null ? void 0 : r.headerBackgroundImage,
          $headerBackgroundImageRepeat: r == null ? void 0 : r.headerBackgroundImageRepeat,
          $headerBackgroundImageSize: r == null ? void 0 : r.headerBackgroundImageSize,
          $headerBackgroundImagePosition: r == null ? void 0 : r.headerBackgroundImagePosition,
          $headerBackgroundImageOrigin: r == null ? void 0 : r.headerBackgroundImageOrigin,
          style: {
            padding: r.containerHeaderPadding
          }
        })
      }), c && /* @__PURE__ */ i(k.Provider, {
        value: a.background,
        children: /* @__PURE__ */ i(l, {
          style: {
            height: g.autoHeight ? "auto" : "100%",
            margin: "0px",
            padding: "0px"
          },
          hideScrollbar: !I,
          children: /* @__PURE__ */ i(G, {
            $showBorder: n,
            ...P,
            items: m(B),
            autoHeight: g.autoHeight,
            emptyRows: 14,
            minHeight: n ? "143px" : "142px",
            containerPadding: n && $ || n ? [u, 11.5] : [u, 11],
            hintPlaceholder: o.hintPlaceholder ?? v,
            $backgroundColor: (a == null ? void 0 : a.background) || "transparent",
            $borderColor: d == null ? void 0 : d.border,
            $borderWidth: d == null ? void 0 : d.borderWidth,
            $backgroundImage: a == null ? void 0 : a.backgroundImage,
            $backgroundImageRepeat: a == null ? void 0 : a.backgroundImageRepeat,
            $backgroundImageSize: a == null ? void 0 : a.backgroundImageSize,
            $backgroundImagePosition: a == null ? void 0 : a.backgroundImagePosition,
            $backgroundImageOrigin: a == null ? void 0 : a.backgroundImageOrigin,
            style: {
              padding: a.containerBodyPadding
            }
          })
        })
      }), $ && /* @__PURE__ */ i(k.Provider, {
        value: e.footerBackground,
        children: /* @__PURE__ */ i(M, {
          $showBorder: n || c,
          ...w,
          items: m(f),
          autoHeight: !0,
          emptyRows: 5,
          minHeight: c ? "47px" : "46px",
          containerPadding: c || n ? [u, 3.5] : [u, 3],
          showName: {
            top: n || c ? 20 : 0
          },
          $backgroundColor: (e == null ? void 0 : e.footerBackground) || "transparent",
          $footerBackgroundImage: e == null ? void 0 : e.footerBackgroundImage,
          $footerBackgroundImageRepeat: e == null ? void 0 : e.footerBackgroundImageRepeat,
          $footerBackgroundImageSize: e == null ? void 0 : e.footerBackgroundImageSize,
          $footerBackgroundImagePosition: e == null ? void 0 : e.footerBackgroundImagePosition,
          $footerBackgroundImageOrigin: e == null ? void 0 : e.footerBackgroundImageOrigin,
          $borderColor: d == null ? void 0 : d.border,
          $borderWidth: d == null ? void 0 : d.borderWidth,
          style: {
            padding: e.containerFooterPadding
          }
        })
      })]
    })
  });
}
export {
  V as TriContainer
};
