import { X as d, Y as o, w as u, cD as c, a1 as p, Z as m, cE as y, O as t, U as f, F as a, a6 as i, G as C, a7 as n, a8 as s, af as l, a9 as v, aa as h, ac as w, ab as g, ek as b } from "./27705007.js";
import { useContext as r } from "react";
import { mediaCommonChildren as E, mediaMethods as P } from "./61930a5a.js";
import "react-dom";
const x = d.div`
  height: 100%;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: center;

  div > audio {
    object-fit: contain;
    pointer-events: auto;
    height: 100%;
    width: 100%;
    :focus-visible {
      outline: 0px;
    }
  }
`, D = [{
  label: o("audio.play"),
  value: "play",
  description: o("audio.playDesc")
}, {
  label: o("audio.pause"),
  value: "pause",
  description: o("audio.pauseDesc")
}, {
  label: o("audio.ended"),
  value: "ended",
  description: o("audio.endedDesc")
}], S = (e) => /* @__PURE__ */ a(x, {
  ref: e.containerRef,
  children: /* @__PURE__ */ a(b, {
    audioRef: e.viewRef,
    url: e.src.value,
    onPlay: () => e.onEvent("play"),
    onPause: () => e.onEvent("pause"),
    onEnded: () => e.onEvent("ended"),
    autoPlay: e.autoPlay,
    loop: e.loop
  })
}), V = {
  src: u(c, o("audio.defaultSrcUrl")),
  onEvent: p(D),
  style: m(y),
  autoPlay: t,
  loop: t,
  ...E
};
let M = function() {
  return new f(V, (e) => /* @__PURE__ */ a(S, {
    ...e
  })).setPropertyViewFn((e) => /* @__PURE__ */ i(C, {
    children: [/* @__PURE__ */ a(n, {
      name: s.basic,
      children: e.src.propertyView({
        label: o("audio.src"),
        tooltip: o("audio.srcDesc")
      })
    }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && /* @__PURE__ */ i(n, {
      name: s.interaction,
      children: [e.onEvent.getPropertyView(), v(e), e.autoPlay.propertyView({
        label: o("audio.autoPlay")
      }), e.loop.propertyView({
        label: o("audio.loop")
      })]
    })]
  })).setExposeMethodConfigs(P()).build();
}();
const N = h(M, [new w("src", o("audio.srcDesc")), g]);
export {
  N as AudioComp
};
