import { X as t, af as P, de as z, a6 as b, F as g, df as c, dh as u, dn as C, dt as v, at as R, au as O, av as W, dm as m } from "./27705007.js";
import { useContext as H } from "react";
import "react-dom";
const F = (o) => R`
    border-radius: ${o.radius ? o.radius : "4px"};
    border: ${o.borderWidth ? o.borderWidth : "0px"} solid ${o.border};
    color: ${o.text};
    font-size: ${o.textSize} !important;
    font-weight: ${o.textWeight} !important;
    font-family: ${o.fontFamily} !important;
    font-style:${o.fontStyle} !important;
    text-transform:${o.textTransform} !important;
    text-decoration:${o.textDecoration} !important;
    background-color: ${o.background};
    .markdown-body a {
      color: ${o.links};
    }
    .markdown-body {
      margin: ${o.margin} !important;	
      padding: ${o.padding};	
      width: ${O(o.margin)};	
      // height: ${W(o.margin)};
      h1 {
        line-height: 1.5;
      }
      h5 {
        line-height: 2.2;
      }
    }

    .markdown-body {
      &,
      p,
      div,
      h1,
      h2,
      h3,
      h4,
      h5,
      h6 {
        color: ${o.text};
      }
      img,
      pre {
        background-color: ${o.background};
        code {
          color: #000000;
        }
      }
    }
  `, G = t.div`
  display: flex;
  flex-flow: column;
  height: 100%;
  border: ${(o) => o.$style.borderWidth} solid ${(o) => o.$style.border};
  border-radius: ${(o) => o.$style.radius};
  background-color: ${(o) => o.$style.background};
  padding: ${(o) => o.$style.padding};
  margin: ${(o) => o.$style.margin};
  ${(o) => o.$style.backgroundImage && `background-image: ${o.$style.backgroundImage};`}
  ${(o) => o.$style.backgroundImageRepeat && `background-repeat: ${o.$style.backgroundImageRepeat};`}
  ${(o) => o.$style.backgroundImageSize && `background-size: ${o.$style.backgroundImageSize};`}
  ${(o) => o.$style.backgroundImagePosition && `background-position: ${o.$style.backgroundImagePosition};`}
  ${(o) => o.$style.backgroundImageOrigin && `background-origin: ${o.$style.backgroundImageOrigin};`}
`, T = t.div`
  ${(o) => o.$style && F(o.$style)}
  text-align: ${(o) => o.$horizontalAlignment};
  padding: ${(o) => o.$style.padding};
  margin: ${(o) => o.$style.margin};
`, A = t(m)`
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$headerBackgroundImage && `background-image: ${o.$headerBackgroundImage};`}
  ${(o) => o.$headerBackgroundImageRepeat && `background-repeat: ${o.$headerBackgroundImageRepeat};`}
  ${(o) => o.$headerBackgroundImageSize && `background-size: ${o.$headerBackgroundImageSize};`}
  ${(o) => o.$headerBackgroundImagePosition && `background-position: ${o.$headerBackgroundImagePosition};`}
  ${(o) => o.$headerBackgroundImageOrigin && `background-origin: ${o.$headerBackgroundImageOrigin};`}
`, j = t(m)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  flex: 1;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$backgroundImage && `background-image: ${o.$backgroundImage};`}
  ${(o) => o.$backgroundImageRepeat && `background-repeat: ${o.$backgroundImageRepeat};`}
  ${(o) => o.$backgroundImageSize && `background-size: ${o.$backgroundImageSize};`}
  ${(o) => o.$backgroundImagePosition && `background-position: ${o.$backgroundImagePosition};`}
  ${(o) => o.$backgroundImageOrigin && `background-origin: ${o.$backgroundImageOrigin};`}
`, D = t(m)`
  border-top: ${(o) => `${o.$showBorder ? o.$borderWidth : 0} solid ${o.$borderColor}`};
  overflow: visible;
  ${(o) => o.$backgroundColor && `background-color: ${o.$backgroundColor};`}
  border-radius: 0;
  ${(o) => o.$footerBackgroundImage && `background-image: ${o.$footerBackgroundImage};`}
  ${(o) => o.$footerBackgroundImageRepeat && `background-repeat: ${o.$footerBackgroundImageRepeat};`}
  ${(o) => o.$footerBackgroundImageSize && `background-size: ${o.$footerBackgroundImageSize};`}
  ${(o) => o.$footerBackgroundImagePosition && `background-position: ${o.$footerBackgroundImagePosition};`}
  ${(o) => o.$footerBackgroundImageOrigin && `background-origin: ${o.$footerBackgroundImageOrigin};`}
`;
function V(o) {
  const {
    container: d,
    text: k
  } = o, {
    showHeader: i,
    showFooter: $
  } = d, h = d.showBody || !i && !$, {
    items: I,
    ...s
  } = d.header, {
    items: l,
    ...B
  } = d.body[0].children.view.getView(), {
    items: f,
    ...w
  } = d.footer, x = H(P).getAppSettings().maxWidth;
  z(x);
  const {
    style: n,
    headerStyle: a,
    bodyStyle: e,
    footerStyle: r
  } = d;
  return /* @__PURE__ */ b(G, {
    $style: n,
    children: [i && /* @__PURE__ */ g(c.Provider, {
      value: d.style.background,
      children: /* @__PURE__ */ g(A, {
        ...s,
        items: u(I),
        autoHeight: !0,
        emptyRows: 5,
        minHeight: "46px",
        containerPadding: [0, 0],
        showName: {
          bottom: $ ? 20 : 0
        },
        $backgroundColor: (a == null ? void 0 : a.headerBackground) || "transparent",
        $headerBackgroundImage: a == null ? void 0 : a.headerBackgroundImage,
        $headerBackgroundImageRepeat: a == null ? void 0 : a.headerBackgroundImageRepeat,
        $headerBackgroundImageSize: a == null ? void 0 : a.headerBackgroundImageSize,
        $headerBackgroundImagePosition: a == null ? void 0 : a.headerBackgroundImagePosition,
        $headerBackgroundImageOrigin: a == null ? void 0 : a.headerBackgroundImageOrigin,
        style: {
          padding: a.containerHeaderPadding
        }
      })
    }), h && /* @__PURE__ */ g(c.Provider, {
      value: d.style.background,
      children: /* @__PURE__ */ b("div", {
        style: {
          overflowY: "scroll",
          background: `${d.style.background}`
        },
        children: [/* @__PURE__ */ g(j, {
          $showBorder: !1,
          ...B,
          items: u(l),
          autoHeight: d.autoHeight,
          emptyRows: 14,
          minHeight: i ? "143px" : "142px",
          containerPadding: [0, 0],
          hintPlaceholder: o.hintPlaceholder ?? C,
          $backgroundColor: (e == null ? void 0 : e.background) || "transparent",
          $borderColor: n == null ? void 0 : n.border,
          $borderWidth: n == null ? void 0 : n.borderWidth,
          $backgroundImage: e == null ? void 0 : e.backgroundImage,
          $backgroundImageRepeat: e == null ? void 0 : e.backgroundImageRepeat,
          $backgroundImageSize: e == null ? void 0 : e.backgroundImageSize,
          $backgroundImagePosition: e == null ? void 0 : e.backgroundImagePosition,
          $backgroundImageOrigin: e == null ? void 0 : e.backgroundImageOrigin,
          style: {
            float: `${o.float}`,
            width: `${o.float === "none" ? "100%" : `${o.width}%`}`,
            height: "100%",
            ...d.bodyStyle
          }
        }), /* @__PURE__ */ g(T, {
          $style: o.style,
          $horizontalAlignment: o.horizontalAlignment,
          children: /* @__PURE__ */ g("p", {
            children: o.type === "markdown" ? /* @__PURE__ */ g(v, {
              children: k.value
            }) : k.value
          })
        })]
      })
    }), $ && /* @__PURE__ */ g(c.Provider, {
      value: d.style.background,
      children: /* @__PURE__ */ g(D, {
        $showBorder: i,
        ...w,
        items: u(f),
        autoHeight: !0,
        emptyRows: 5,
        minHeight: "48px",
        containerPadding: [0, 0],
        showName: {
          top: i ? 20 : 0
        },
        $backgroundColor: (r == null ? void 0 : r.footerBackground) || "transparent",
        $footerBackgroundImage: r == null ? void 0 : r.footerBackgroundImage,
        $footerBackgroundImageRepeat: r == null ? void 0 : r.footerBackgroundImageRepeat,
        $footerBackgroundImageSize: r == null ? void 0 : r.footerBackgroundImageSize,
        $footerBackgroundImagePosition: r == null ? void 0 : r.footerBackgroundImagePosition,
        $footerBackgroundImageOrigin: r == null ? void 0 : r.footerBackgroundImageOrigin,
        $borderColor: n == null ? void 0 : n.border,
        $borderWidth: n == null ? void 0 : n.borderWidth,
        style: {
          padding: r.containerFooterPadding
        }
      })
    })]
  });
}
export {
  V as TriContainer
};
