import { X as l, dq as u, Y as o, a3 as p, ax as w, a2 as g, dr as x, Z as f, ds as $, U as b, F as a, dt as C, a6 as n, G as m, a7 as r, a8 as i, af as h, a9 as y, aa as v, ac as k, ab as A, at as S, au as V, av as T, al as z, an as H, am as F } from "./27705007.js";
import { useContext as c } from "react";
import { MarginControl as M } from "./7258737d.js";
import { PaddingControl as B } from "./2c63bd89.js";
import "react-dom";
const P = (t) => S`
    border-radius: ${t.radius ? t.radius : "4px"};
    border: ${t.borderWidth ? t.borderWidth : "0px"} solid ${t.border};
    color: ${t.text};
    font-size: ${t.textSize} !important;
    font-weight: ${t.textWeight} !important;
    font-family: ${t.fontFamily} !important;
    font-style:${t.fontStyle} !important;
    text-transform:${t.textTransform} !important;
    text-decoration:${t.textDecoration} !important;
    background-color: ${t.background};
    .markdown-body a {
      color: ${t.links};
    }
    .markdown-body {
      margin: ${t.margin} !important;	
      padding: ${t.padding};	
      width: ${V(t.margin)};	
      // height: ${T(t.margin)};
      h1 {
        line-height: 1.5;
      }
      h5 {
        line-height: 2.2;
      }
    }

    .markdown-body {
      &,
      p,
      div,
      h1,
      h2,
      h3,
      h4,
      h5,
      h6 {
        color: ${t.text};
      }
      img,
      pre {
        background-color: ${t.background};
        code {
          color: #000000;
        }
      }
    }
  `, W = l.div`
  height: 100%;
  overflow: auto;
  margin: 0;
  ${(t) => t.$type === "text" && "white-space:break-spaces;line-height: 1.9;"};
  ${(t) => t.$styleConfig && P(t.$styleConfig)}
  display: flex;
  font-size: 13px;
  ${u};
  overflow-wrap: anywhere;
  .markdown-body {
    overflow-wrap: anywhere;
  }
`, j = l(z)`
  transform: rotate(90deg);
`, D = l(H)`
  transform: rotate(90deg);
`, E = l(F)`
  transform: rotate(90deg);
`, N = [{
  label: "Markdown",
  value: "markdown"
}, {
  label: o("text"),
  value: "text"
}], R = [{
  label: /* @__PURE__ */ a(j, {}),
  value: "flex-start"
}, {
  label: /* @__PURE__ */ a(E, {}),
  value: "center"
}, {
  label: /* @__PURE__ */ a(D, {}),
  value: "flex-end"
}];
let d = function() {
  const t = {
    text: p("text", o("textShow.text", {
      name: "{{currentUser.name}}"
    })),
    autoHeight: w,
    type: g(N, "markdown"),
    horizontalAlignment: x(),
    verticalAlignment: g(R, "center"),
    style: f($),
    margin: M,
    padding: B
  };
  return new b(t, (e) => {
    const s = e.text.value;
    return /* @__PURE__ */ a(W, {
      $type: e.type,
      $styleConfig: e.style,
      style: {
        justifyContent: e.horizontalAlignment,
        alignItems: e.autoHeight ? "center" : e.verticalAlignment,
        textAlign: e.horizontalAlignment
      },
      children: e.type === "markdown" ? /* @__PURE__ */ a(C, {
        children: s
      }) : s
    });
  }).setPropertyViewFn((e) => /* @__PURE__ */ n(m, {
    children: [/* @__PURE__ */ n(r, {
      name: i.basic,
      children: [e.type.propertyView({
        label: o("value"),
        tooltip: o("textShow.valueTooltip"),
        radioButton: !0
      }), e.text.propertyView({})]
    }), ["logic", "both"].includes(c(h).editorModeStatus) && /* @__PURE__ */ a(r, {
      name: i.interaction,
      children: y(e)
    }), ["layout", "both"].includes(c(h).editorModeStatus) && /* @__PURE__ */ n(m, {
      children: [/* @__PURE__ */ n(r, {
        name: i.layout,
        children: [e.autoHeight.getPropertyView(), !e.autoHeight.getView() && e.verticalAlignment.propertyView({
          label: o("textShow.verticalAlignment"),
          radioButton: !0
        }), e.horizontalAlignment.propertyView({
          label: o("textShow.horizontalAlignment"),
          radioButton: !0
        })]
      }), /* @__PURE__ */ a(r, {
        name: i.style,
        children: e.style.getPropertyView()
      })]
    })]
  })).build();
}();
d = class extends d {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const J = v(d, [new k("text", o("textShow.textDesc")), A]);
export {
  J as TextComp
};
