import { eV as n, eW as i, at as a, X as d, Z as s, et as c, bR as t, cN as g, d4 as $, cP as p, d5 as f, bU as h } from "./27705007.js";
import "react";
import "react-dom";
function l(r) {
  const o = n(r.background), e = i(r.background);
  return a`
    &&& {
      border-radius: ${r.radius};
      border-width:${r.borderWidth};
      margin: ${r.margin};	
      padding: ${r.padding};
      &:not(:disabled) {
        --antd-wave-shadow-color: ${r.border};
        border-color: ${r.border};
        color: ${r.text};
        font-size: ${r.textSize};
        font-weight: ${r.textWeight};
        font-family: ${r.fontFamily};
        font-style: ${r.fontStyle};
        text-transform:${r.textTransform};
        text-decoration:${r.textDecoration};
        background-color: ${r.background};
        border-radius: ${r.radius};
        margin: ${r.margin};	
        padding: ${r.padding};
  
        &:hover,
        &:focus {
          color: ${r.text};
          background-color: ${o};
          border-color: ${r.border === r.background ? o : r.border} !important;
        }
        &:active {
          color: ${r.text};
          background-color: ${e};
          border-color: ${r.border === r.background ? e : r.border} !important;
        }
      }
    }
  `;
}
const k = d(h)`
  ${(r) => r.$buttonStyle && l(r.$buttonStyle)}
  width: 100%;
  height: auto;
  display: inline-flex;
  justify-content: center;
  align-items: center;
  overflow: hidden;
  gap: 6px; 
  span {
    overflow: hidden;
    text-overflow: ellipsis;
  }
`, w = d.div`
  // The button component is disabled but can respond to drag & select events
  ${(r) => r.disabled && `
    cursor: not-allowed;
    button:disabled {
      pointer-events: none;
    }
  `};
`;
function m(r) {
  return r && (r.hasOwnProperty("backgroundColor") || r.hasOwnProperty("borderColor") || r.hasOwnProperty("color")) ? {
    background: r.backgroundColor,
    border: r.borderColor,
    text: r.color
  } : r;
}
const x = s(c), C = t(x, m), B = g([$, p, f]);
export {
  k as Button100,
  w as ButtonCompWrapper,
  C as ButtonStyleControl,
  B as buttonRefMethods,
  l as getButtonStyle
};
