import { at as d, X as u, Y as t, a1 as p, cc as b, a3 as g, Z as w, hG as y, hH as h, a2 as m, O as c, w as P, e7 as C, U as f, F as o, _ as v, a6 as i, G as x, a7 as a, a8 as l, bJ as k, a9 as V, ac as s, hI as S } from "./27705007.js";
import "react";
import { FormDataPropertyView as E } from "./3abf5a92.js";
import { textInputChildren as $ } from "./a6ad9758.js";
import { presets as O } from "./fc6c22e1.js";
import "react-dom";
function j(e) {
  return d`
    border-radius: ${e.radius};
    &:not(.ant-input-disabled, .ant-input-affix-wrapper-disabled),
    input {
      background-color: ${e.background};
      border-color: ${e.border};
      &:focus,
      &.ant-input-affix-wrapper-focused {
        border-color: ${e.accent};
      }
      &:hover {
        border-color: ${e.accent};
      }
      .ant-input-clear-icon svg:hover {
        opacity: 0.65;
      }
    }
  `;
}
const A = u(S)`
  width: 100%;
  display: flex;
  justify-content: flex-start;
  ${(e) => e.$style && j(e.$style)}
`, H = [{
  label: t("colorPicker.click"),
  value: "click"
}, {
  label: t("colorPicker.hover"),
  value: "hover"
}], U = p([b]), D = {
  ...$,
  value: g("value", "#3377ff"),
  style: w(y),
  color: h("color", {}),
  trigger: m(H, "click"),
  disabledAlpha: c,
  showPresets: c,
  onEvent: U,
  presets: P(C, JSON.stringify(O, null, 2))
}, T = new f(D, (e) => {
  var n;
  return e.label({
    children: /* @__PURE__ */ o(A, {
      $style: e.style,
      value: (n = e == null ? void 0 : e.value) == null ? void 0 : n.value,
      disabledAlpha: e.disabledAlpha,
      showText: (r) => r.toHexString().toUpperCase(),
      allowClear: !0,
      trigger: e.trigger,
      disabled: e.disabled,
      onChange: (r) => {
        e.value.onChange(r.toHexString().toUpperCase()), e.color.onChange({
          hex: r.toHexString().toUpperCase(),
          hsb: r.toHsb(),
          rgb: r.toRgb()
        }), e.onEvent("change");
      },
      presets: e.showPresets && !v.isEmpty(e.presets) ? [e.presets] : []
    }),
    style: e.style
  });
}).setPropertyViewFn((e) => /* @__PURE__ */ i(x, {
  children: [/* @__PURE__ */ o(a, {
    name: l.basic,
    children: e.value.propertyView({
      label: t("prop.defaultValue")
    })
  }), /* @__PURE__ */ o(E, {
    ...e
  }), e.label.getPropertyView(), /* @__PURE__ */ i(a, {
    name: l.interaction,
    children: [e.onEvent.getPropertyView(), k(e)]
  }), /* @__PURE__ */ i(a, {
    name: l.advanced,
    children: [e.trigger.propertyView({
      label: t("colorPicker.trigger"),
      radioButton: !0
    }), e.disabledAlpha.propertyView({
      label: t("colorPicker.disabledAlpha")
    }), e.showPresets.propertyView({
      label: t("colorPicker.showPresets")
    }), e.showPresets.getView() && e.presets.propertyView({
      label: t("colorPicker.recommended")
    })]
  }), /* @__PURE__ */ o(a, {
    name: l.layout,
    children: V(e)
  }), /* @__PURE__ */ o(a, {
    name: l.style,
    children: e.style.getPropertyView()
  })]
})).setExposeStateConfigs([new s("value", t("export.inputValueDesc")), new s("color", t("export.inputValueDesc")), new s("disabled", t("prop.disabled"))]).build();
export {
  T as ColorPickerComp,
  U as colorPickerEvent,
  j as getStyle
};
