import { newCustomColumn as T } from "./f49d1356.js";
import { X as w, fH as E, at as O, fI as B, Y as t, a6 as d, G as b, F as l, a7 as a, bO as S, fJ as M, a8 as x, a9 as z, bK as D, fK as L, fL as F, fM as G, bP as v, fN as $, fO as W, di as N, fP as j, fQ as J, fR as Q, fS as U, fT as X, ev as Y, fU as Z, dZ as k, cx as A, fV as q } from "./27705007.js";
import { useState as P, useMemo as _ } from "react";
import { getSelectedRowKeys as K } from "./6ac33f0f.js";
import { ColumnTypeCompMap as ee } from "./7c475e24.js";
import "./f2012eba.js";
import "react-dom";
import "./45a5c9de.js";
import "./b4a7ec31.js";
import "./7eb8d04b.js";
import "./6c3cad93.js";
import "./873a5a93.js";
import "./67f8c31d.js";
import "./1775f119.js";
import "./32ef42f2.js";
import "./cbd516f7.js";
import "./3abf5a92.js";
import "./f2f054b8.js";
import "./a6ad9758.js";
import "./445db0b6.js";
import "./49730c28.js";
import "./e776c04e.js";
import "./6cb8a142.js";
import "./82842dd9.js";
import "./63fb00e4.js";
import "./1cc8ebd7.js";
import "./b975e7ae.js";
import "./8b9b6162.js";
import "./789437ad.js";
import "./653cdbc4.js";
import "./2c63bd89.js";
import "./7258737d.js";
import "./498cc5be.js";
import "./ff4c4040.js";
import "./c8dac94d.js";
import "./e7ff85cb.js";
const te = w.div`
  display: flex;
  justify-content: end;
  width: 100%;
  gap: 8px;
  align-items: center;
`, ie = w.span`
  ${E};
  color: #8b8fa3;
`, le = w(L)`
  width: 16px;
  height: 16px;
  cursor: pointer;

  &:hover {
    g g {
      stroke: #4965f2;
    }
  }
`, I = O`
  height: 16px;
  width: 16px;
  display: inline-block;

  &:hover {
    cursor: pointer;
  }

  &:hover path {
    fill: #315efb;
  }
`, oe = w(F)`
  ${I}
`, re = w(G)`
  ${I}
`, ne = w(v)`
  width: 100px;

  &,
  > div {
    height: 22px;
  }

  .ant-segmented-item-label {
    height: 18px;
    min-height: 18px;
    line-height: 18px;
    padding: 0;
  }
`, ae = w.div`
  display: flex;
  align-items: center;
  color: ${B}
  line-height: 16px;
  font-size: 13px;
`, de = [{
  label: t("table.allColumn"),
  value: "all"
}, {
  label: t("table.visibleColumn"),
  value: "visible"
}], ce = [{
  label: t("prop.hide"),
  value: "hide"
}, {
  label: t("table.editable"),
  value: "editable"
}, {
  label: t("table.autoWidth"),
  value: "autoWidth"
}, {
  label: t("table.sortable"),
  value: "sortable"
}, {
  label: t("table.align"),
  value: "align"
}];
function se(e) {
  const {
    hide: i,
    setHide: s
  } = e;
  return /* @__PURE__ */ l(i ? oe : re, {
    onClick: (r) => {
      s(!i);
    }
  });
}
function V(e, i) {
  const s = (r) => e === "autoWidth" ? r.children.autoWidth.getView() === "auto" : r.children[e].getView(), h = i ?? ((r) => r);
  return (r) => {
    const p = Array.isArray(r), y = p ? r : [r], f = y.map((c) => {
      if (e !== "editable")
        return !1;
      const m = c.children.render.getOriginalComp().children.comp.children.compType.getView();
      return !ee[m].canBeEditable();
    });
    let u = !0, g = !0;
    y.forEach((c, m) => {
      if (f[m]) {
        p || (u = !1);
        return;
      }
      s(c) ? g = !1 : u = !1;
    });
    const C = (c) => {
      y.forEach((m, o) => !f[o] && m.children[e].dispatch(k(A(h(c), !0))));
    };
    return e === "hide" ? /* @__PURE__ */ l(se, {
      hide: u,
      setHide: (c) => C(c)
    }) : /* @__PURE__ */ l(q, {
      indeterminate: !u && !g,
      disabled: !p && f[0],
      checked: u,
      onChange: (c) => {
        C(c.target.checked);
      }
    });
  };
}
const R = {
  hide: V("hide"),
  editable: V("editable"),
  sortable: V("sortable"),
  autoWidth: V("autoWidth", (e) => e ? "auto" : "fixed"),
  align: (e) => {
    const i = Array.isArray(e) ? e : [e], s = Array.isArray(e) ? void 0 : e.children.align.getView();
    return /* @__PURE__ */ l(ne, {
      options: Z,
      value: s,
      radioButton: !0,
      onChange: (h) => {
        i.forEach((r) => r.children.align.dispatch(k(A(h, !0))));
      }
    });
  }
};
function he(e) {
  const {
    comp: i
  } = e, s = K(i.children.selection)[0] ?? "0", [h, r] = P("all"), p = i.children.columns.getView(), y = i.children.dataRowExample.getView(), f = i.children.dynamicColumn.getView(), u = i.children.data.getView(), [g, C] = P("hide"), c = _(() => p.filter((o) => h === "all" || !o.children.hide.getView()), [h, p]), m = /* @__PURE__ */ d(te, {
    children: [/* @__PURE__ */ d("div", {
      style: {
        display: "flex",
        alignItems: "center",
        marginRight: "auto"
      },
      children: [/* @__PURE__ */ l($, {
        label: e.columnLabel
      }), /* @__PURE__ */ l(ie, {
        children: " (" + p.length + ")"
      })]
    }), y && /* @__PURE__ */ l(W, {
      title: t("table.refreshButtonTooltip"),
      children: /* @__PURE__ */ l(le, {
        onClick: () => {
          i.dispatch(N("columns", i.children.columns.dataChangedAction({
            rowExample: y,
            doGeneColumn: !0,
            dynamicColumn: f,
            data: u
          })));
        }
      })
    }), /* @__PURE__ */ l(j, {
      icon: /* @__PURE__ */ l(J, {}),
      text: t("addItem"),
      onClick: () => {
        i.children.columns.dispatch(i.children.columns.pushAction(T()));
      }
    })]
  });
  return /* @__PURE__ */ l(b, {
    children: /* @__PURE__ */ l(Q, {
      headerItem: /* @__PURE__ */ l(U, {
        title: /* @__PURE__ */ l(v, {
          border: !0,
          style: {
            width: "auto",
            marginLeft: "8px"
          },
          value: h,
          options: de,
          label: "",
          onChange: (o) => {
            r(o);
          }
        }),
        config: {
          dataIndex: "header"
        },
        draggable: !1,
        optionExtra: /* @__PURE__ */ d(ae, {
          children: [/* @__PURE__ */ l(v, {
            border: !0,
            style: {
              width: "auto"
            },
            value: g,
            options: ce,
            label: "",
            onChange: (o) => {
              C(o);
            }
          }), R[g](p)]
        })
      }),
      itemExtra: (o) => /* @__PURE__ */ l("div", {
        style: {
          display: "flex",
          alignItems: "center",
          height: "100%"
        },
        onClick: (n) => n.stopPropagation(),
        children: R[g](o)
      }),
      items: c,
      optionToolbar: m,
      itemTitle: (o) => {
        const n = o.getView();
        return n.hide ? /* @__PURE__ */ l("span", {
          style: {
            color: B
          },
          children: n.title
        }) : n.title;
      },
      popoverTitle: (o) => {
        const n = o.getView();
        return n.isCustom ? t("table.customColumn") : n.dataIndex;
      },
      content: (o, n) => /* @__PURE__ */ d(b, {
        children: [o.propertyView(s), o.getView().isCustom && /* @__PURE__ */ l(X, {
          onClick: () => {
            Y.confirm({
              title: t("table.deleteColumn"),
              content: t("table.confirmDeleteColumn") + `${o.getView().title}?`,
              onConfirm: () => i.children.columns.dispatch(i.children.columns.deleteAction(n)),
              confirmBtnType: "delete",
              okText: t("delete")
            });
          },
          children: t("delete")
        })]
      }),
      onAdd: () => {
        i.children.columns.dispatch(i.children.columns.pushAction(T()));
      },
      onMove: (o, n) => {
        const H = i.children.columns.arrayMoveAction(o, n);
        i.children.columns.dispatch(H);
      },
      dataIndex: (o) => o.getView().dataIndex,
      scrollable: !0
    })
  });
}
function pe(e) {
  const i = t("table.columnNum");
  return [
    S({
      filterText: i
    }, /* @__PURE__ */ l(he, {
      comp: e,
      columnLabel: i
    }))
    /* comp.children.dynamicColumn.propertyView({ label: trans("table.dynamicColumn") }),
    dynamicColumn &&
      comp.children.dynamicColumnConfig.propertyView({
        label: trans("table.dynamicColumnConfig"),
        tooltip: trans("table.dynamicColumnConfigDesc"),
      }), */
  ];
}
function Ye(e) {
  const i = e.editorModeStatus, s = t("data");
  return /* @__PURE__ */ d(b, {
    children: [["logic", "both"].includes(i) && /* @__PURE__ */ l(a, {
      name: t("table.dataDesc"),
      children: S({
        filterText: s
      }, /* @__PURE__ */ l("div", {
        className: M,
        children: e.children.data.propertyView({
          label: s
        })
      }))
    }), ["layout", "both"].includes(i) && /* @__PURE__ */ l(a, {
      name: t("prop.columns"),
      children: pe(e)
    }), ["logic", "both"].includes(i) && /* @__PURE__ */ d(b, {
      children: [/* @__PURE__ */ d(a, {
        name: x.interaction,
        children: [e.children.onEvent.getPropertyView(), e.children.selection.getPropertyView(), z(e.children), D(e.children)]
      }), /* @__PURE__ */ l(a, {
        name: t("prop.toolbar"),
        children: e.children.toolbar.getPropertyView()
      })]
    }), ["layout", "both"].includes(i) && /* @__PURE__ */ d(b, {
      children: [/* @__PURE__ */ d(a, {
        name: x.layout,
        children: [e.children.size.propertyView({
          label: t("table.tableSize"),
          radioButton: !0
        }), e.children.autoHeight.getPropertyView(), e.children.fixedHeader.propertyView({
          label: t("table.fixedHeader"),
          tooltip: t("table.fixedHeaderTooltip")
        }), e.children.hideHeader.propertyView({
          label: t("table.hideHeader")
        }), e.children.viewModeResizable.propertyView({
          label: t("table.viewModeResizable"),
          tooltip: t("table.viewModeResizableTooltip")
        }), e.children.visibleResizables.propertyView({
          label: t("table.visibleResizables"),
          tooltip: t("table.visibleResizablesTooltip")
        })]
      }), /* @__PURE__ */ l(a, {
        name: t("prop.pagination"),
        children: e.children.pagination.getPropertyView()
      })]
    }), ["logic", "both"].includes(i) && /* @__PURE__ */ l(b, {
      children: /* @__PURE__ */ d(a, {
        name: x.advanced,
        children: [e.children.expansion.getPropertyView(), e.children.showDataLoadSpinner.propertyView({
          label: t("table.showDataLoadSpinner")
        }), e.children.dynamicColumn.propertyView({
          label: t("table.dynamicColumn")
        }), e.children.dynamicColumn.getView() && e.children.dynamicColumnConfig.propertyView({
          label: t("table.dynamicColumnConfig"),
          tooltip: t("table.dynamicColumnConfigDesc")
        }), e.children.searchText.propertyView({
          label: t("table.searchText"),
          tooltip: t("table.searchTextTooltip"),
          placeholder: "{{input1.value}}"
        })]
      })
    }), ["layout", "both"].includes(i) && /* @__PURE__ */ d(b, {
      children: [/* @__PURE__ */ l(a, {
        name: "Table Style",
        children: e.children.style.getPropertyView()
      }), /* @__PURE__ */ l(a, {
        name: "Header Style",
        children: e.children.headerStyle.getPropertyView()
      }), /* @__PURE__ */ l(a, {
        name: "Toolbar Style",
        children: e.children.toolbarStyle.getPropertyView()
      }), /* @__PURE__ */ d(a, {
        name: "Row Style",
        children: [e.children.showRowGridBorder.propertyView({
          label: t("table.showVerticalRowGridBorder")
        }), e.children.showHRowGridBorder.propertyView({
          label: t("table.showHorizontalRowGridBorder")
        }), e.children.rowStyle.getPropertyView(), e.children.rowAutoHeight.getPropertyView(), e.children.rowHeight.getPropertyView(), e.children.rowColor.getPropertyView()]
      }), /* @__PURE__ */ l(a, {
        name: "Column Style",
        children: e.children.columnsStyle.getPropertyView()
      })]
    })]
  });
}
export {
  Ye as compTablePropertyView
};
