import { e_ as R, Y as r, e$ as w, _ as L, ca as T, bL as S, a3 as f, bI as y, P as I, S as $, f0 as E, O as v, a0 as h, a2 as P, f1 as M, cf as k, a6 as i, a7 as u, a8 as c, eh as B, bJ as O, c8 as N, dA as q, dB as A, dC as D, at as _, cN as U, d4 as W, cP as z, f2 as F, f3 as j, d5 as H, f4 as J, f5 as g } from "./27705007.js";
import { useState as K, useRef as x, useEffect as m } from "react";
import { formDataChildren as Y } from "./3abf5a92.js";
import "react-dom";
const p = [{
  label: "Text",
  value: "Text",
  extra: /.*/,
  help: ""
}, {
  label: "Email",
  value: "Email",
  extra: R,
  help: r("validationDesc.email")
}, {
  label: "URL",
  value: "URL",
  extra: w,
  help: r("validationDesc.url")
}, {
  label: "Regex",
  value: "Regex",
  extra: void 0,
  help: r("validationDesc.regex")
}], l = L.fromPairs(p.map((e) => [e.value, e])), b = (e) => {
  var o;
  if (e.customRule)
    return {
      validateStatus: "error",
      help: e.customRule
    };
  const t = e.value.value;
  if (e.required && t.length === 0)
    return {
      validateStatus: "error",
      help: r("prop.required")
    };
  if (e.maxLength > 0 && t.length > e.maxLength)
    return {
      validateStatus: "error",
      help: r("validationDesc.maxLength", {
        length: t.length,
        maxLength: e.maxLength
      })
    };
  if (e.minLength > 0 && t.length < e.minLength)
    return {
      validateStatus: "error",
      help: r("validationDesc.minLength", {
        length: t.length,
        minLength: e.minLength
      })
    };
  const a = e.validationType, n = ((o = l[a]) == null ? void 0 : o.extra) ?? e.regex;
  return t && !n.test(t) ? {
    validateStatus: "error",
    help: l[a].help
  } : {
    validateStatus: ""
  };
}, G = T({
  name: "invalid",
  desc: r("export.invalidDesc"),
  depKeys: ["value", "required", "minLength", "maxLength", "validationType", "regex", "customRule"],
  func: (e) => b({
    ...e,
    value: {
      value: e.value
    }
  }).validateStatus !== ""
}), ae = [G, ...S], ne = {
  defaultValue: f("defaultValue"),
  value: f("value"),
  disabled: y,
  label: I,
  placeholder: $,
  onEvent: E,
  readOnly: v,
  // validation
  required: v,
  minLength: h,
  maxLength: h,
  validationType: P(p, "Text"),
  regex: M,
  customRule: k,
  ...Y
}, Q = (e) => ({
  disabled: e.disabled,
  readOnly: e.readOnly,
  placeholder: e.placeholder,
  defaultValue: e.defaultValue.value,
  value: e.value.value,
  onFocus: () => e.onEvent("focus"),
  onBlur: () => e.onEvent("blur"),
  onPressEnter: () => e.onEvent("submit")
}), oe = (e) => {
  const [t, a] = K({}), n = x(!1), o = x(e);
  o.current = e;
  const s = {
    ...e.defaultValue
  }.value, d = {
    ...e.value
  }.value;
  m(() => {
    e.value.onChange(s);
  }, [s]), m(() => {
    n.current && (a(b({
      ...o.current,
      value: {
        value: d
      }
    })), o.current.onEvent("change"), n.current = !1);
  }, [d]);
  const V = (C) => {
    e.value.onChange(C.target.value), n.current = !0;
  };
  return [{
    ...Q(e),
    onChange: V
  }, t];
}, re = (e) => /* @__PURE__ */ i(u, {
  name: c.basic,
  children: [e.defaultValue.propertyView({
    label: r("prop.defaultValue")
  }), B(e)]
}), le = (e) => /* @__PURE__ */ i(u, {
  name: c.interaction,
  children: [e.onEvent.getPropertyView(), O(e)]
}), ie = (e) => {
  var t;
  return /* @__PURE__ */ i(u, {
    name: c.validation,
    children: [N(e), e.validationType.propertyView({
      label: r("prop.textType")
    }), ((t = l[e.validationType.getView()]) == null ? void 0 : t.extra) === void 0 && q(e), A(e), D(e), e.customRule.propertyView({})]
  });
};
function ue(e, t) {
  return _`
    border-radius: ${e.radius};
    border-width: ${e.borderWidth};
    padding: ${e.padding};	
    // still use antd style when disabled
    &:not(.ant-input-disabled, .ant-input-affix-wrapper-disabled),
    input {
      color: ${e.text};
      font-size: ${e.textSize};
      font-weight: ${e.textWeight};
      font-family: ${e.fontFamily};
      font-style:${e.fontStyle};
      text-transform:${e.textTransform};
      text-decoration:${e.textDecoration};
      background-color: ${e.background};
      border-color: ${e.border};

      &:focus,
      &.ant-input-affix-wrapper-focused {
        border-color: ${e.accent};
      }

      &:hover {
        border-color: ${e.accent};
      }

      &::-webkit-input-placeholder {
        color: ${e.text};
        opacity: 0.4;
      }

      .ant-input-show-count-suffix,
      .ant-input-prefix,
      .ant-input-suffix svg {
        opacity: 0.45;
        color: ${e.text};
      }

      .ant-input-clear-icon svg:hover {
        opacity: 0.65;
      }
    }
  `;
}
const ce = [...U([W, z, F, j]), {
  method: H,
  execute: (e, t) => {
    var a, n;
    return (n = (a = e.children.viewRef.viewRef) == null ? void 0 : a.input) == null ? void 0 : n.click();
  }
}, {
  method: J,
  execute: (e, t) => {
    var a, n, o;
    return (o = (n = (a = e.children.viewRef.viewRef) == null ? void 0 : a.input) == null ? void 0 : n.setRangeText) == null ? void 0 : o.call(n, ...t);
  }
}];
function se(e) {
  if (e === "")
    return {};
  for (const t in e)
    g(e[t], ["array"], t, (a) => (g(a, ["string"]), a));
  return e;
}
function de(e) {
  if (!e)
    return e;
  if (e.value && !e.defaultValue) {
    const t = e.value;
    return {
      ...e,
      defaultValue: t,
      value: ""
    };
  }
  return e;
}
export {
  re as TextInputBasicSection,
  ae as TextInputConfigs,
  le as TextInputInteractionSection,
  p as TextInputValidationOptions,
  ie as TextInputValidationSection,
  se as checkMentionListData,
  de as fixOldInputCompData,
  ue as getStyle,
  ce as inputRefMethods,
  ne as textInputChildren,
  Q as textInputProps,
  b as textInputValidate,
  oe as useTextInputProps
};
