import { X as C, at as P, au as B, av as E, Y as r, U as z, F as a, af as s, ay as F, a6 as l, G as g, a7 as d, a8 as m, bJ as N, a9 as D, bK as M, aa as L, ac as T, bL as W, bM as j, w as b, S as R, a2 as k, ax as O, bH as U, bI as $, L as A, N as G, bN as J, bO as K, bP as X, ag as Y } from "./27705007.js";
import { useState as S, useRef as V, useEffect as q, useContext as h } from "react";
import { Button100 as Q, ButtonStyleControl as Z } from "./f51c4aac.js";
import "react-dom";
const _ = C.div`
  height: 100%;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  ${(t) => t.$style && tt(t.$style)}
`, tt = (t) => P`
    button {
      border: 1px solid ${t.border};
      border-radius: ${t.radius};
      margin: ${t.margin};
      padding: ${t.padding};
      max-width: ${B(t.margin)};
      max-height: ${E(t.margin)};
    }
  `, et = C(j)`
  font-size: 13px;
  margin-right: 4px;
`, nt = C.div`
  display: flex;

  ${(t) => t.$style && it(t.$style)}
`;
function it(t) {
  return P`
    svg {
      width: ${t.size} !important;
      height: ${t.size} !important;
    }
  `;
}
function ot(t) {
  return t.uiCompInfoList().filter((e) => e.type === "form").map((e) => ({
    label: e.name,
    value: e.name
  }));
}
function w(t, e) {
  const n = t == null ? void 0 : t.getUICompByName(e);
  if (n && n.children.compType.getView() === "form")
    return n.children.comp;
}
function at(t, e) {
  const n = w(t, e);
  if (n)
    return /* @__PURE__ */ a(Y.Provider, {
      value: e,
      children: n.onEventPropertyView(/* @__PURE__ */ l(g, {
        children: [/* @__PURE__ */ a(et, {
          onClick: () => t.setSelectedCompNames(/* @__PURE__ */ new Set([e]), "rightPanel"),
          children: e
        }), r("button.formButtonEvent")]
      }))
    });
}
class rt extends J {
  getPropertyView() {
    const e = r("button.formToSubmit");
    return K({
      filterText: e
    }, /* @__PURE__ */ a(s.Consumer, {
      children: (n) => /* @__PURE__ */ l(g, {
        children: [/* @__PURE__ */ a(X, {
          label: e,
          value: this.value,
          options: ot(n),
          onChange: (c) => this.dispatchChangeValueAction(c),
          allowClear: !0
        }), at(n, this.value)]
      })
    }));
  }
}
const lt = [{
  label: r("button.default"),
  value: ""
}, {
  label: r("button.submit"),
  value: "submit"
}];
function H(t) {
  return !t;
}
function st(t, e) {
  const n = w(t, e);
  n && n.submit();
}
const ut = {
  iconSize: b(R, "20px"),
  type: k(lt, ""),
  autoHeight: b(O, "fixed"),
  aspectRatio: b(R, "1 / 1"),
  onEvent: U,
  disabled: $,
  loading: $,
  form: rt,
  prefixIcon: A,
  style: Z,
  viewRef: G
};
let y = function() {
  return new z(ut, (t) => {
    const [e, n] = S(120), [c, ct] = S(0), f = V(null), p = V(null);
    q(() => {
      c && e && x();
    }, [c, e]);
    const I = (i, o) => {
      const u = f.current, v = u == null ? void 0 : u.getElementsByTagName("button")[0];
      u.style.height = i, u.style.width = o, v.style.height = i, v.style.width = o;
    }, x = () => {
      const i = f.current, o = p.current;
      !(i != null && i.clientWidth) || !(i != null && i.clientHeight) || t.autoHeight || !e || I((o == null ? void 0 : o.clientHeight) + "px", (o == null ? void 0 : o.clientWidth) + "px");
    };
    return /* @__PURE__ */ a(s.Consumer, {
      children: (i) => /* @__PURE__ */ a(F, {
        onResize: x,
        render: () => {
          var o;
          return /* @__PURE__ */ a(_, {
            ref: p,
            $style: t.style,
            children: /* @__PURE__ */ a("div", {
              ref: f,
              style: t.autoHeight ? {
                width: "100%",
                height: "100%"
              } : void 0,
              children: /* @__PURE__ */ a(Q, {
                ref: t.viewRef,
                $buttonStyle: t.style,
                loading: t.loading,
                style: t.autoHeight ? {
                  width: "100%",
                  height: "100%",
                  aspectRatio: t.aspectRatio,
                  borderRadius: t.style.radius
                } : {
                  aspectRatio: t.aspectRatio,
                  borderRadius: t.style.radius
                },
                disabled: t.disabled || !H(t.type) && ((o = w(i, t.form)) == null ? void 0 : o.disableSubmit()),
                onClick: () => H(t.type) ? t.onEvent("click") : st(i, t.form),
                children: t.prefixIcon && /* @__PURE__ */ a(nt, {
                  $style: {
                    ...t.style,
                    size: t.iconSize
                  },
                  children: t.prefixIcon
                })
              })
            })
          });
        }
      })
    });
  }).setPropertyViewFn((t) => /* @__PURE__ */ l(g, {
    children: [/* @__PURE__ */ a(d, {
      name: m.basic,
      children: t.prefixIcon.propertyView({
        label: r("button.icon")
      })
    }), (h(s).editorModeStatus === "logic" || h(s).editorModeStatus === "both") && /* @__PURE__ */ l(d, {
      name: m.interaction,
      children: [t.onEvent.getPropertyView(), N(t), D(t), M(t)]
    }), (h(s).editorModeStatus === "layout" || h(s).editorModeStatus === "both") && /* @__PURE__ */ l(g, {
      children: [/* @__PURE__ */ l(d, {
        name: m.layout,
        children: [t.autoHeight.getPropertyView(), t.iconSize.propertyView({
          label: r("button.iconSize")
        })]
      }), /* @__PURE__ */ l(d, {
        name: m.style,
        children: [t.style.getPropertyView(), t.aspectRatio.propertyView({
          label: r("style.aspectRatio")
        })]
      })]
    })]
  })).build();
}();
y = class extends y {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const ft = L(y, [new T("loading", r("button.loadingDesc")), ...W]);
export {
  ft as ControlButton
};
