import { at as r, cR as h, X as u, cS as c, P as b, bI as x, cT as k, cU as f, Z as n, c0 as s, c1 as m, a2 as $, N as g, cV as p, U as v, F as i, aa as C, ac as S, Y as w, bL as B, cW as I, bR as W } from "./27705007.js";
import { SelectInputValidationChildren as F, useSelectInputValidate as R, selectDivRefMethods as V, SelectInputInvalidConfig as D } from "./cbd516f7.js";
import { formDataChildren as E } from "./3abf5a92.js";
import { RadioLayoutOptions as y, RadioPropertyView as z } from "./f2f054b8.js";
import "react";
import { fixOldInputCompData as L } from "./a6ad9758.js";
import "react-dom";
const O = (e) => r`
    &,
    .ant-checkbox-wrapper:not(.ant-checkbox-wrapper-disabled) {
      color: ${e.staticText};
      max-width: calc(100% - 8px);

      span:not(.ant-checkbox) {
        ${h};
      }

      .ant-checkbox-checked {
        .ant-checkbox-inner {
          background-color: ${e.checkedBackground};
          border-color: ${e.checkedBackground};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};

          &::after {
            border-color: ${e.checked};
          }
        }

        &::after {
          border-color: ${e.checkedBackground};
          border-width:${e.borderWidth ? e.borderWidth : "2px"};
          border-radius: ${e.radius};
        }
      }
      
      .ant-checkbox-inner {
        border-radius: ${e.radius};
        background-color: ${e.uncheckedBackground};
        border-color: ${e.uncheckedBorder};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    
      &:hover .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#fff"};
      }

      &:hover .ant-checkbox-checked .ant-checkbox-inner, 
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input + ant-checkbox-inner {
        background-color:${e.hoverBackground ? e.hoverBackground : "#ffff"};
      }

      &:hover .ant-checkbox-inner,
      .ant-checkbox:hover .ant-checkbox-inner,
      .ant-checkbox-input:focus + .ant-checkbox-inner {
        border-color: ${e.checkedBackground};
        border-width:${e.borderWidth ? e.borderWidth : "2px"};
      }
    }

    

    .ant-checkbox-group-item {
      font-family:${e.fontFamily};
      font-size:${e.textSize};
      font-weight:${e.textWeight};
      font-style:${e.fontStyle};
      text-transform:${e.textTransform};
      text-decoration:${e.textDecoration};
    }
    .ant-checkbox-wrapper {
      padding: ${e.padding};
      .ant-checkbox-inner,
      .ant-checkbox-checked::after {
        border-radius: ${e.radius};
      }
    }
  `, T = u(I)`
  min-height: 32px;
  ${(e) => e.$style && O(e.$style)}
  ${(e) => {
  if (e.$layout === "horizontal")
    return r`
        display: flex;
        align-items: center;
        flex-wrap: wrap;
      `;
  if (e.$layout === "vertical")
    return r`
        display: flex;
        flex-direction: column;
      `;
  if (e.$layout === "auto_columns")
    return r`
        break-inside: avoid;
        columns: 160px;
      `;
}}
`;
let t = function() {
  const e = {
    defaultValue: c("defaultValue"),
    value: c("value"),
    label: b,
    disabled: x,
    onEvent: k,
    options: f,
    style: n(s),
    labelStyle: n(m.filter((o) => ["accent", "validate"].includes(o.name) === !1)),
    layout: $(y, "horizontal"),
    viewRef: g,
    inputFieldStyle: n(p),
    ...F,
    ...E
  };
  return new v(e, (o) => {
    const [d, l] = R(o);
    return o.label({
      required: o.required,
      style: o.style,
      labelStyle: o.labelStyle,
      inputFieldStyle: o.inputFieldStyle,
      children: /* @__PURE__ */ i(T, {
        ref: o.viewRef,
        disabled: o.disabled,
        value: o.value.value,
        $style: o.inputFieldStyle,
        $layout: o.layout,
        options: o.options.filter((a) => a.value !== void 0 && !a.hidden).map((a) => ({
          label: a.label,
          value: a.value,
          disabled: a.disabled
        })),
        onChange: (a) => {
          l(a);
        }
      }),
      ...d
    });
  }).setPropertyViewFn((o) => /* @__PURE__ */ i(z, {
    ...o
  })).setExposeMethodConfigs(V).build();
}();
t = W(t, L);
const A = C(t, [new S("value", w("selectInput.valueDesc")), D, ...B]);
export {
  A as CheckboxComp,
  O as getStyle
};
