import { X as E, Y as t, a2 as g, P as L, w as P, S as F, ed as k, O as m, a as A, Z as p, c0 as I, c1 as M, eg as N, N as D, U as H, F as i, a6 as a, G as S, a7 as o, a8 as r, eh as O, af as c, dv as R, ei as B, aa as U, ac as W, ej as d, as as _ } from "./27705007.js";
import { useContext as u, useEffect as $ } from "react";
import { treeCommonChildren as j, treeDataPropertyView as q, formSection as G, valuePropertyView as K, TreeNameConfigs as X, useTree as Y } from "./4b7c4026.js";
import { getStyle as Z, baseSelectRefMethods as z } from "./653cdbc4.js";
import { SelectInputValidationSection as J, useSelectInputValidate as Q } from "./cbd516f7.js";
import "react-dom";
import "./3abf5a92.js";
import "./8a5661c0.js";
import "./2c63bd89.js";
import "./7258737d.js";
const ee = E(d)`
  width: 100%;
  ${(e) => e.$style && Z(e.$style)}
`, te = [{
  label: t("tree.singleSelect"),
  value: "single"
}, {
  label: t("tree.multiSelect"),
  value: "multi"
}, {
  label: t("tree.checkbox"),
  value: "check"
}], le = [{
  label: t("tree.showAll"),
  value: "all"
}, {
  label: t("tree.showParent"),
  value: "parent"
}, {
  label: t("tree.showChild"),
  value: "child"
}], ae = {
  ...j,
  selectType: g(te, "single"),
  checkedStrategy: g(le, "parent"),
  label: L,
  placeholder: P(F, t("tree.placeholder")),
  // TODO: more event
  onEvent: k,
  allowClear: m,
  showSearch: m.DEFAULT_TRUE,
  inputValue: A(""),
  // search value
  style: p(I),
  labelStyle: p(M),
  inputFieldStyle: p(N),
  viewRef: D
};
function oe(e) {
  switch (e) {
    case "all":
      return d.SHOW_ALL;
    case "parent":
      return d.SHOW_PARENT;
    case "child":
      return d.SHOW_CHILD;
  }
}
const re = (e) => {
  const {
    treeData: y,
    selectType: s,
    value: n,
    expanded: b,
    style: C,
    labelStyle: f,
    inputValue: V
  } = e, h = s === "single", [v, T] = Q(e);
  return $(() => {
    h && n.value.length > 1 && n.onChange(n.value.slice(0, 1));
  }, [s]), Y(e), e.label({
    required: e.required,
    ...v,
    style: C,
    labelStyle: f,
    inputFieldStyle: e.inputFieldStyle,
    children: /* @__PURE__ */ i(ee, {
      ref: e.viewRef,
      $style: e.inputFieldStyle,
      popupMatchSelectWidth: !1,
      disabled: e.disabled,
      placeholder: e.placeholder,
      allowClear: e.allowClear,
      fieldNames: {
        label: "label",
        value: "value"
      },
      treeData: y,
      multiple: !h,
      value: h ? n.value[0] : n.value,
      treeCheckable: s === "check",
      showCheckedStrategy: oe(e.checkedStrategy),
      treeLine: e.showLine ? {
        showLeafIcon: e.showLeafIcon
      } : !1,
      treeExpandedKeys: V ? void 0 : b.value,
      onTreeExpand: (l) => {
        b.onChange(l);
      },
      onChange: (l) => {
        const x = Array.isArray(l) ? l : l !== void 0 ? [l] : [];
        T(x);
      },
      showSearch: e.showSearch,
      treeNodeFilterProp: "label",
      autoClearSearchValue: !1,
      onSearch: (l) => {
        e.dispatch(_("inputValue", l, !1));
      },
      onFocus: () => e.onEvent("focus"),
      onBlur: () => e.onEvent("blur")
    }, s)
  });
};
let w = function() {
  return new H(ae, (e, y) => /* @__PURE__ */ i(re, {
    ...e,
    dispatch: y
  })).setPropertyViewFn((e) => /* @__PURE__ */ a(S, {
    children: [/* @__PURE__ */ a(o, {
      name: r.basic,
      children: [q(e), O(e)]
    }), ["logic", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ a(S, {
      children: [/* @__PURE__ */ i(J, {
        ...e
      }), G(e), /* @__PURE__ */ a(o, {
        name: r.interaction,
        children: [e.onEvent.getPropertyView(), e.hidden.propertyView({
          label: t("prop.hide")
        }), e.disabled.propertyView({
          label: t("prop.disabled")
        }), e.selectType.propertyView({
          label: t("tree.selectType")
        }), K(e), e.selectType.getView() === "check" && e.checkedStrategy.propertyView({
          label: t("tree.checkedStrategy")
        }), R(e), B(e)]
      })]
    }), ["layout", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ a(o, {
      name: r.layout,
      children: [e.expanded.propertyView({
        label: t("tree.expanded")
      }), e.defaultExpandAll.propertyView({
        label: t("tree.defaultExpandAll")
      }), e.showLine.propertyView({
        label: t("tree.showLine")
      }), e.showLine.getView() && e.showLeafIcon.propertyView({
        label: t("tree.showLeafIcon")
      })]
    }), ["layout", "both"].includes(u(c).editorModeStatus) && e.label.getPropertyView(), ["layout", "both"].includes(u(c).editorModeStatus) && /* @__PURE__ */ a(S, {
      children: [/* @__PURE__ */ i(o, {
        name: r.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ i(o, {
        name: r.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ i(o, {
        name: r.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      })]
    })]
  })).setExposeMethodConfigs(z).build();
}();
w = class extends w {
  autoHeight() {
    return !0;
  }
};
const we = U(w, [...X, new W("inputValue", t("select.inputValueDesc"))]);
export {
  we as TreeSelectComp
};
