import { at as p, eX as m, eY as h, X as s, P as b, S as f, bI as w, ed as S, cZ as x, O as u, a as $, N as C, Z as v, d0 as V, F as a, fb as y, as as P, a6 as o, bT as F, G as i, a7 as l, a8 as n, Y as I, eh as M, af as c, bJ as k, a9 as E, dv as D, ei as R, cN as T, cO as B, cP as O, fc as A } from "./27705007.js";
import { PaddingControl as L } from "./2c63bd89.js";
import { MarginControl as N } from "./7258737d.js";
import { useContext as d } from "react";
import { SelectInputValidationChildren as U, SelectInputValidationSection as W } from "./cbd516f7.js";
import { formDataChildren as j, FormDataPropertyView as z } from "./3abf5a92.js";
import "react-dom";
const X = (e) => p`
    &.ant-select .ant-select-selector,
    &.ant-select-multiple .ant-select-selection-item {
      border-radius: ${e.radius};
      padding: ${e.padding};	
      height: auto;	
    }	
    .ant-select-selection-search {	
      padding: ${e.padding};
    }	
    .ant-select-selection-search-input {
      font-family:${e.fontFamily} !important;
      text-transform:${e.textTransform} !important;
      text-decoration:${e.textDecoration} !important;
      font-size:${e.textSize} !important;
      font-weight:${e.textWeight};
      color:${e.text} !important;
      font-style:${e.fontStyle};
    }
    .ant-select-selector::after,	
    .ant-select-selection-placeholder,	
    .ant-select-selection-item {	
      line-height: 1.5715 !important;
    }

    &.ant-select:not(.ant-select-disabled) {
      color: ${e.text};
      .ant-select-selection-placeholder,
      .ant-select-selection-item {
        line-height: 1.5715 !important;
      }
      .ant-select-selection-placeholder,
      &.ant-select-single.ant-select-open .ant-select-selection-item {
        color: ${e.text};
        opacity: 0.4;
        width: 100%;
      }

      .ant-select-selector {
        background-color: ${e.background};
        border-color: ${e.border};
        border-width:${e.borderWidth};
      }

      &.ant-select-focused,
      &:hover {
        .ant-select-selector {
          border-color: ${e.accent};
        }
      }

      .ant-select-arrow,
      .ant-select-clear {
        background-color: ${e.background};
        color: ${e.text === "#222222" ? "#8B8FA3" : m(e.text) ? h(e.text, 0.2) : e.text};
      }

      .ant-select-clear:hover {
        color: ${e.text === "#222222" ? "#8B8FA3" : m(e.text) ? h(e.text, 0.1) : e.text};
      }

      &.ant-select-multiple .ant-select-selection-item {
        border: none;
        background-color: ${e.tags};
        color: ${e.tagsText};
        border-radius: ${e.radius};

        .ant-select-selection-item-remove {
          color: ${e.tagsText};
          opacity: 0.5;
        }
      }
    }
  `, Y = (e) => p`
    padding: 8px 0;

    .ant-select-item-option-selected {
      font-weight: 600;
      background-color: transparent;
    }

    .ant-select-item {
      border-radius: 4px;
      margin: 0 8px;
      padding: 5px 8px;

      &:hover {
        background-color: rgb(242, 247, 252);
      }

      .ant-select-item-option-state {
        display: inline-flex;
        align-items: center;

        path {
          fill: ${e.multiIcon};
        }
      }
    }
  `, g = s(A)`
  width: 100%;

  ${(e) => e.$style && X(e.$style)}
`, Z = s.div`
  ${(e) => e.$style && Y(e.$style)}
  .ant-select-item-option-content {
    ${(e) => `padding: ${e.$style.padding}`};
  }
  .option-label img {
    min-width: 14px;
    margin-right: 0;
  }
`, G = s.span`
  display: inline-flex;
  align-items: center;
  gap: 6px;

  img {
    margin-right: -6px;
  }
`, te = {
  label: b,
  placeholder: f,
  disabled: w,
  onEvent: S,
  options: x,
  allowClear: u,
  inputValue: $(""),
  // user's input value when search
  showSearch: u.DEFAULT_TRUE,
  viewRef: C,
  margin: N,
  padding: L,
  inputFieldStyle: v(V),
  ...U,
  ...j
}, ae = (e) => /* @__PURE__ */ a(g, {
  ref: e.viewRef,
  mode: e.mode,
  $style: e.style,
  disabled: e.disabled,
  allowClear: e.allowClear,
  placeholder: e.placeholder,
  value: e.value,
  showSearch: e.showSearch,
  filterOption: (t, r) => r == null ? void 0 : r.label.toLowerCase().includes(t.toLowerCase()),
  dropdownRender: (t) => /* @__PURE__ */ a(Z, {
    $style: e.style,
    children: t
  }),
  dropdownStyle: {
    padding: 0
  },
  menuItemSelectedIcon: e.mode ? /* @__PURE__ */ a(y, {
    title: ""
  }) : "",
  onChange: e.onChange,
  onFocus: () => e.onEvent("focus"),
  onBlur: () => e.onEvent("blur"),
  onSearch: e.showSearch ? (t) => {
    e.dispatch(P("inputValue", t, !1));
  } : void 0,
  children: e.options.filter((t) => t.value !== void 0 && !t.hidden).map((t) => /* @__PURE__ */ a(g.Option, {
    value: t.value,
    label: t.label,
    disabled: t.disabled,
    children: /* @__PURE__ */ o(G, {
      className: "option-label",
      children: [e.options.findIndex((r) => F(r.prefixIcon)) > -1 && t.prefixIcon, /* @__PURE__ */ a("span", {
        children: t.label
      })]
    })
  }, t.value))
}), oe = (e) => /* @__PURE__ */ o(i, {
  children: [/* @__PURE__ */ o(l, {
    name: n.basic,
    children: [e.options.propertyView({}), e.defaultValue.propertyView({
      label: I("prop.defaultValue")
    }), M(e)]
  }), ["logic", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ o(i, {
    children: [/* @__PURE__ */ o(i, {
      children: [/* @__PURE__ */ a(W, {
        ...e
      }), /* @__PURE__ */ a(z, {
        ...e
      })]
    }), /* @__PURE__ */ o(l, {
      name: n.interaction,
      children: [e.onEvent.getPropertyView(), k(e), E(e)]
    })]
  }), ["layout", "both"].includes(d(c).editorModeStatus) && e.label.getPropertyView(), ["logic", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ o(l, {
    name: n.advanced,
    children: [D(e), R(e)]
  }), ["layout", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ o(i, {
    children: [/* @__PURE__ */ a(l, {
      name: n.style,
      children: e.style.getPropertyView()
    }), /* @__PURE__ */ a(l, {
      name: n.labelStyle,
      children: e.labelStyle.getPropertyView()
    }), /* @__PURE__ */ a(l, {
      name: n.inputFieldStyle,
      children: e.inputFieldStyle.getPropertyView()
    })]
  })]
}), le = T([B, O]);
export {
  te as SelectChildrenMap,
  oe as SelectPropertyView,
  ae as SelectUIView,
  le as baseSelectRefMethods,
  X as getStyle
};
