import { cc as h, Y as l, X as b, d1 as y, P as m, a1 as w, bI as C, Z as i, c0 as g, c1 as f, N as p, bR as S, d2 as v, U as k, F as a, d3 as P, a6 as s, G as u, a7 as n, a8 as o, af as c, bJ as x, a9 as F, cN as V, d4 as E, cP as M, d5 as $, aa as N, ac as O, bL as R, at as I } from "./27705007.js";
import { useContext as d } from "react";
import { formDataChildren as L, FormDataPropertyView as j } from "./3abf5a92.js";
import "react-dom";
const B = [h, {
  label: l("switchComp.open"),
  value: "true",
  description: l("switchComp.openDesc")
}, {
  label: l("switchComp.close"),
  value: "false",
  description: l("switchComp.closeDesc")
}], U = (t) => I`
    .ant-switch-handle::before {
      background-color: ${t.handle};
    }
    button {
      background-image: none;
      background-color: ${t.unchecked};
      &.ant-switch-checked {
        background-color: ${t.checked};
      }
    }
  `, W = b.div`
  min-height: 32px;
  display: flex;
  align-items: center;
  // Can respond to drag & select events when disabled
  ${(t) => t.disabled && `
    cursor: not-allowed;
    >button:disabled {
      pointer-events: none;
    }
  `};
  ${(t) => t.$style && U(t.$style)}
`;
function D(t) {
  return t && t.hasOwnProperty("unChecked") ? {
    label: t.label,
    handle: t.handle,
    unchecked: t.unChecked,
    checked: t.checked
  } : t;
}
let G = function() {
  const t = {
    value: y("value"),
    label: m,
    onEvent: w(B),
    disabled: C,
    style: i(g),
    labelStyle: i(f.filter((e) => ["accent", "validate"].includes(e.name) === !1)),
    viewRef: p,
    inputFieldStyle: S(i(v), D),
    ...L
  };
  return new k(t, (e) => e.label({
    style: e.style,
    labelStyle: e.labelStyle,
    inputFieldStyle: e.inputFieldStyle,
    children: /* @__PURE__ */ a(W, {
      disabled: e.disabled,
      $style: e.inputFieldStyle,
      children: /* @__PURE__ */ a(P, {
        checked: e.value.value,
        disabled: e.disabled,
        ref: e.viewRef,
        onChange: (r) => {
          e.value.onChange(r), e.onEvent("change"), e.onEvent(r ? "true" : "false");
        }
      })
    })
  })).setPropertyViewFn((e) => /* @__PURE__ */ s(u, {
    children: [/* @__PURE__ */ a(n, {
      name: o.basic,
      children: e.value.propertyView({
        label: l("switchComp.defaultValue")
      })
    }), /* @__PURE__ */ a(j, {
      ...e
    }), ["logic", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ s(n, {
      name: o.interaction,
      children: [e.onEvent.getPropertyView(), x(e), F(e)]
    }), ["layout", "both"].includes(d(c).editorModeStatus) && e.label.getPropertyView(), ["layout", "both"].includes(d(c).editorModeStatus) && /* @__PURE__ */ s(u, {
      children: [/* @__PURE__ */ a(n, {
        name: o.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ a(n, {
        name: o.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ a(n, {
        name: o.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      })]
    })]
  })).setExposeMethodConfigs(V([E, M, $])).build();
}();
const Y = N(G, [new O("value", l("switchComp.valueDesc")), ...R]);
export {
  Y as SwitchComp
};
