import { X as O, Y as o, a3 as L, cH as q, S as B, bI as U, O as w, P as A, a2 as _, w as j, a0 as G, b$ as H, f0 as K, N as W, Z as S, c0 as z, c1 as X, L as J, du as Y, cf as Z, U as Q, F as h, a6 as f, G as C, a7 as v, a8 as p, eh as ee, af as c, c8 as te, bJ as ae, a9 as re, dw as ne, cb as oe, cN as ue, d4 as ie, cP as le, d5 as de, f2 as se, f3 as ce, f4 as me, aa as be, ca as E, dx as fe, dy as ve, bL as pe, at as he, au as ge, av as we, gF as Ne, cC as ye, bT as Se, bR as Ce } from "./27705007.js";
import { useContext as m, useRef as xe, useEffect as F, useState as Ve } from "react";
import { formDataChildren as Ie, FormDataPropertyView as Me } from "./3abf5a92.js";
import { fixOldInputCompData as $e } from "./a6ad9758.js";
import "react-dom";
function M(e, t) {
  return t === void 0 && (t = 15), +parseFloat(Number(e).toPrecision(t));
}
function d(e) {
  var t = e.toString().split(/[eE]/), a = (t[0].split(".")[1] || "").length - +(t[1] || 0);
  return a > 0 ? a : 0;
}
function N(e) {
  if (e.toString().indexOf("e") === -1)
    return Number(e.toString().replace(".", ""));
  var t = d(e);
  return t > 0 ? M(Number(e) * Math.pow(10, t)) : Number(e);
}
function x(e) {
  D && (e > Number.MAX_SAFE_INTEGER || e < Number.MIN_SAFE_INTEGER) && console.warn(e + " is beyond boundary when transfer to integer, the results may not be accurate");
}
function y(e) {
  return function() {
    for (var t = [], a = 0; a < arguments.length; a++)
      t[a] = arguments[a];
    var r = t[0], i = t.slice(1);
    return i.reduce(function(l, s) {
      return e(l, s);
    }, r);
  };
}
var b = y(function(e, t) {
  var a = N(e), r = N(t), i = d(e) + d(t), l = a * r;
  return x(l), l / Math.pow(10, i);
}), Ee = y(function(e, t) {
  var a = Math.pow(10, Math.max(d(e), d(t)));
  return (b(e, a) + b(t, a)) / a;
}), Fe = y(function(e, t) {
  var a = Math.pow(10, Math.max(d(e), d(t)));
  return (b(e, a) - b(t, a)) / a;
}), k = y(function(e, t) {
  var a = N(e), r = N(t);
  return x(a), x(r), b(a / r, M(Math.pow(10, d(t) - d(e))));
});
function Re(e, t) {
  var a = Math.pow(10, t), r = k(Math.round(Math.abs(b(e, a))), a);
  return e < 0 && r !== 0 && (r = b(r, -1)), r;
}
var D = !0;
function Pe(e) {
  e === void 0 && (e = !0), D = e;
}
var V = {
  strip: M,
  plus: Ee,
  minus: Fe,
  times: b,
  divide: k,
  round: Re,
  digitLength: d,
  float2Fixed: N,
  enableBoundaryChecking: Pe
};
const ke = (e) => he`
    border-radius: ${e.radius};
    border-width:${e.borderWidth} !important;
    // still use antd style when disabled
    &:not(.ant-input-number-disabled) {
      color: ${e.text};
      background-color: ${e.background};
      border-color: ${e.border};
      //margin: ${e.margin};	
      padding: 0;	
      width: ${ge(e.margin)};
      &.ant-input-number-focused {
        border-color: ${e.accent};
      }

      &:hover {
        border-color: ${e.accent};
      }

      &::-webkit-input-placeholder {
        color: ${e.text};
        opacity: 0.4;
      }
      .ant-input-number {	
        margin: 0;	
        
      }	
      .ant-input-number-input {	
        margin: 0;	
        padding: ${e.padding};	
        height: ${we(e.margin)};	
        color:${e.text};
        font-family:${e.fontFamily} !important;
        font-weight:${e.textWeight} !important;
        font-size:${e.textSize} !important;
        font-style:${e.fontStyle} !important;
      }

      .ant-input-number-handler-wrap {
        background-color: ${e.background};
        border-radius: 0 ${e.radius} ${e.radius} 0;

        .ant-input-number-handler span {
          color: ${e.text};
          opacity: 0.45;

          &:hover {
            opacity: 1;
          }
        }

        .ant-input-number-handler-up {
          border-top-right-radius: ${e.radius};
        }

        .ant-input-number-handler-down {
          border-bottom-right-radius: ${e.radius};
        }
      }
    }
  `, De = O(Ne)`
  width: 100%;
  ${(e) => e.$style && ke(e.$style)}
`, Te = [{
  label: o("numberInput.standard"),
  value: "standard"
}, {
  label: o("numberInput.percent"),
  value: "percent"
}];
function R(e, t) {
  const a = e.replace(/[^\d.-]/g, "");
  if (a) {
    const r = Number(a);
    if (isFinite(r))
      return r;
  }
  return t ? Number.NaN : 0;
}
function Oe(e) {
  const t = e.toString().split(".");
  return t[0] = t[0].replace(/\B(?=(\d{3})+(?!\d))/g, ","), t.join(".");
}
function Le(e, t, a, r, i) {
  const l = e;
  if (isNaN(l))
    return "";
  let s = l.toFixed(r);
  switch (i && (s = Oe(s)), a) {
    case "standard":
      return s;
    case "percent":
      return s + "%";
  }
}
function qe(e, t, a) {
  const r = e;
  if (isNaN(r))
    return t ? null : 0;
  switch (a) {
    case "standard":
      return r;
    case "percent":
      return V.divide(r, 100);
  }
}
function T(e) {
  if (e.customRule)
    return {
      validateStatus: "error",
      help: e.customRule
    };
  const t = e.value.value;
  return isNaN(t) ? e.required ? {
    validateStatus: "error",
    help: o("prop.required")
  } : {
    validateStatus: ""
  } : e.max !== void 0 && t > e.max ? {
    validateStatus: "error",
    help: o("validationDesc.maxValue", {
      value: t,
      max: e.max
    })
  } : e.min !== void 0 && t < e.min ? {
    validateStatus: "error",
    help: o("validationDesc.minValue", {
      value: t,
      min: e.min
    })
  } : {
    validateStatus: ""
  };
}
const P = ye((e) => {
  if (typeof e == "number")
    return e;
  const t = Number(e);
  return !e || isNaN(t) ? void 0 : t;
}), Be = {
  defaultValue: L("defaultValue"),
  // It is more convenient for string to handle various states, save raw input here
  value: q("value"),
  // It is more convenient for string to handle various states, save raw input here
  placeholder: B,
  disabled: U,
  readOnly: w,
  label: A,
  formatter: _(Te, "standard"),
  step: j(G, 1),
  controls: w.DEFAULT_TRUE,
  // Whether to display the increase or decrease button
  precision: H.closed(0, 20, 0),
  thousandsSeparator: w.DEFAULT_TRUE,
  // Whether to display the thousand separator
  allowNull: w,
  onEvent: K,
  viewRef: W,
  style: S(z),
  labelStyle: S(X),
  prefixIcon: J,
  inputFieldStyle: S(Y),
  // validation
  required: w,
  min: P,
  max: P,
  customRule: Z,
  ...Ie
}, Ue = (e) => {
  const t = xe(null), a = e.defaultValue.value;
  F(() => {
    let n = 0;
    a === "null" && e.allowNull ? n = NaN : isNaN(Number(a)) || (n = Number(a)), e.value.onChange(n);
  }, [a]);
  const r = (n) => Le(n, e.allowNull, e.formatter, e.precision, e.thousandsSeparator), [i, l] = Ve(r(e.value.value)), s = () => {
    const n = e.value.value, u = R(i, e.allowNull);
    e.value.onChange(u), n !== u && e.onEvent("change");
  };
  return F(() => {
    l(r(e.value.value));
  }, [e.value.value, e.allowNull, e.formatter, e.precision, e.thousandsSeparator]), /* @__PURE__ */ h(De, {
    ref: (n) => {
      e.viewRef(n), t.current = n;
    },
    value: i,
    controls: e.controls,
    step: e.step,
    disabled: e.disabled,
    readOnly: e.readOnly,
    placeholder: e.placeholder,
    stringMode: !0,
    precision: e.precision,
    $style: e.inputFieldStyle,
    prefix: Se(e.prefixIcon) && e.prefixIcon,
    onPressEnter: () => {
      s(), e.onEvent("submit");
    },
    onChangeCapture: (n) => {
      var u;
      l((((u = n.target.value) == null ? void 0 : u.toString()) ?? "").replace("。", "."));
    },
    onStep: (n, u) => {
      const g = V.plus(R(i), V.times(u.type === "up" ? 1 : -1, Number(u.offset)));
      e.value.onChange(g), e.onEvent("change");
    },
    onFocus: () => {
      e.onEvent("focus");
    },
    onBlur: () => {
      s(), e.onEvent("blur");
    },
    onKeyPress: (n) => {
      var $;
      const u = i, g = ($ = t.current) == null ? void 0 : $.selectionStart;
      /\d/.test(n.key) || g === 0 && n.key === "-" && !/-/.test(u) || g !== 0 && e.thousandsSeparator && n.key === "," || g !== 0 && e.precision > 0 && // eslint-disable-next-line only-ascii/only-ascii
      (n.key === "." || n.key === "。") && !/[.]/.test(u) || n.preventDefault();
    }
  });
};
let I = function() {
  return new Q(Be, (e) => e.label({
    required: e.required,
    children: /* @__PURE__ */ h(Ue, {
      ...e
    }),
    style: e.style,
    labelStyle: e.labelStyle,
    inputFieldStyle: e.inputFieldStyle,
    ...T(e)
  })).setPropertyViewFn((e) => /* @__PURE__ */ f(C, {
    children: [/* @__PURE__ */ f(v, {
      name: p.basic,
      children: [e.defaultValue.propertyView({
        label: o("prop.defaultValue")
      }), ee(e), e.formatter.propertyView({
        label: o("numberInput.formatter")
      })]
    }), /* @__PURE__ */ h(Me, {
      ...e
    }), (m(c).editorModeStatus === "logic" || m(c).editorModeStatus === "both") && /* @__PURE__ */ f(C, {
      children: [/* @__PURE__ */ f(v, {
        name: p.validation,
        children: [te(e), e.min.propertyView({
          label: o("prop.minimum")
        }), e.max.propertyView({
          label: o("prop.maximum")
        }), e.customRule.propertyView({})]
      }), /* @__PURE__ */ f(v, {
        name: p.interaction,
        children: [e.onEvent.getPropertyView(), ae(e), re(e)]
      })]
    }), (m(c).editorModeStatus === "layout" || m(c).editorModeStatus === "both") && e.label.getPropertyView(), (m(c).editorModeStatus === "logic" || m(c).editorModeStatus === "both") && /* @__PURE__ */ f(v, {
      name: p.advanced,
      children: [e.step.propertyView({
        label: o("numberInput.step")
      }), e.precision.propertyView({
        label: o("numberInput.precision")
      }), e.prefixIcon.propertyView({
        label: o("button.prefixIcon")
      }), e.allowNull.propertyView({
        label: o("numberInput.allowNull")
      }), e.thousandsSeparator.propertyView({
        label: o("numberInput.thousandsSeparator")
      }), e.controls.propertyView({
        label: o("numberInput.controls")
      }), ne(e)]
    }), (m(c).editorModeStatus === "layout" || m(c).editorModeStatus === "both") && /* @__PURE__ */ f(C, {
      children: [/* @__PURE__ */ h(v, {
        name: p.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ h(v, {
        name: p.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ h(v, {
        name: p.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      })]
    })]
  })).build();
}();
I = Ce(I, $e);
const Ae = oe(I, ue([ie, le, de, se, ce, me])), We = be(Ae, [E({
  name: "value",
  desc: o("export.inputValueDesc"),
  depKeys: ["value", "allowNull", "formatter"],
  func: (e) => qe(e.value, e.allowNull, e.formatter)
}), fe, ve, E({
  name: "invalid",
  desc: o("export.invalidDesc"),
  depKeys: ["value", "required", "min", "max", "allowNull", "customRule"],
  func: (e) => T({
    ...e,
    value: {
      value: e.value
    }
  }).validateStatus !== ""
}), ...pe]);
export {
  We as NumberInputComp
};
