import { X as m, af as B, fr as U, dN as E, _ as x, F as i, fs as T, de as X, df as Z, a6 as _, dg as q, ay as J, ft as K, fu as Q, dh as Y, dZ as tt, dm as et, dn as it } from "./27705007.js";
import { createContext as nt, useRef as ot, useContext as W, useMemo as o } from "react";
import { ContextContainerComp as at } from "./7f86705a.js";
import "react-dom";
const rt = m.div`
  height: 100%;
  border: 1px solid ${(e) => e.$style.border};
  border-radius: ${(e) => e.$style.radius};
  padding: 3px ${(e) => e.$paddingWidth};
  background-color: ${(e) => e.$style.background};
`, st = m.div`
  display: flex;
  align-items: center;
  justify-content: center;
  padding: 3px;
`, dt = m.div`
  height: ${(e) => e.$autoHeight ? "100%" : "calc(100% - 32px)"};
`, ct = m.div` 
  height: 100%;
  display: flex;
  align-items: center;
  // justify-content: center;
`, lt = m.div`
  height: ${(e) => e.$autoHeight ? "auto" : "100%"};
  display: flex;
  flex-direction: ${(e) => e.$isHorizontal && !e.$isGrid ? "row" : "column"};
  height: 100%;
`, V = nt({
  horizontalWidth: "100%",
  minHorizontalWidth: "100px"
}), gt = (e) => {
  const {
    horizontalWidth: l,
    minHorizontalWidth: t
  } = W(V);
  return /* @__PURE__ */ i("div", {
    style: {
      width: l,
      minWidth: t || "0px"
    },
    children: /* @__PURE__ */ i(et, {
      ...e,
      emptyRows: 15,
      containerPadding: [4, 4],
      hintPlaceholder: it
    })
  });
};
function ht({
  minHorizontalWidth: e,
  horizontalWidth: l,
  ...t
}) {
  const {
    itemIdx: d,
    offset: a,
    containerProps: c,
    autoHeight: w,
    scrollContainerRef: y,
    minHeight: p
  } = t;
  return /* @__PURE__ */ i(V.Provider, {
    value: {
      horizontalWidth: l,
      minHorizontalWidth: e
    },
    children: /* @__PURE__ */ i(gt, {
      layout: c.layout,
      items: Y(c.items),
      positionParams: c.positionParams,
      dispatch: d === a ? c.dispatch : x.noop,
      style: {
        height: "100%",
        // in case of horizontal mode, minHorizontalWidth is 0px
        width: e || "100%",
        backgroundColor: "transparent"
        // flex: "auto",
      },
      autoHeight: w,
      isDroppable: d === a,
      isDraggable: d === a,
      isResizable: d === a,
      isSelectable: d === a,
      scrollContainerRef: y,
      overflow: "hidden",
      minHeight: p,
      enableGridLines: !0
    })
  });
}
function wt(e) {
  const {
    comp: l
  } = e, t = l.children, d = ot(null), a = W(B), c = a.isDragging, [w, y] = U(0, c), p = o(() => t.dynamicHeight.getView(), [t.dynamicHeight]), v = o(() => t.heightUnitOfRow.getView(), [t.heightUnitOfRow]), R = o(() => t.container.getView(), [t.container]), S = o(() => t.itemIndexName.getView(), [t.itemIndexName]), I = o(() => t.itemDataName.getView(), [t.itemDataName]), {
    data: P,
    itemCount: z
  } = o(() => E(t.noOfRows.getView()), [t.noOfRows]), u = o(() => t.autoHeight.getView(), [t.autoHeight]), D = o(() => t.scrollbars.getView(), [t.scrollbars]), $ = o(() => t.horizontal.getView(), [t.horizontal]), O = o(() => t.minHorizontalWidth.getView(), [t.minHorizontalWidth]), h = o(() => Math.max(1, t.noOfColumns.getView()), [t.noOfColumns]), r = o(() => {
    const s = t.pagination.getView(), g = s.total || z;
    let f = s.current, n = (f - 1) * s.pageSize;
    const b = Math.max(0, Math.min(s.pageSize, g - n));
    return {
      pagination: {
        ...s,
        current: f,
        total: g
      },
      offset: n,
      currentPageSize: b,
      total: g
    };
  }, [t.pagination, z]), C = t.style.getView(), M = l.realSimpleContainer().children.layout.getView(), H = r.currentPageSize > 0 && (x.isEmpty(M) || a.isDragging), L = H ? 1 : Math.floor((r.currentPageSize + h - 1) / h), N = H ? "100%" : p ? "auto" : v * 44 + "px", k = c && u ? w + "px" : "100%", F = x.range(0, L).map((s) => /* @__PURE__ */ i("div", {
    style: {
      height: N,
      width: "100%"
    },
    children: /* @__PURE__ */ i(ct, {
      children: x.range(0, h).map((f) => {
        const n = s * h + f + r.offset;
        if (n >= r.total || n >= r.offset + r.pagination.pageSize || H && n > r.offset)
          return /* @__PURE__ */ i("div", {
            style: {
              flex: "auto"
            }
          }, n);
        const b = R({
          [S]: n,
          [I]: T(P, n)
        }, String(n)).getView(), A = () => {
          l.children.container.dispatch(tt(at.batchDeleteAction([String(n)])));
        };
        return /* @__PURE__ */ i(ht, {
          itemIdx: n,
          offset: r.offset,
          containerProps: b,
          autoHeight: c || p,
          scrollContainerRef: d,
          minHeight: k,
          unMountFn: A,
          horizontalWidth: `${100 / h}%`,
          minHorizontalWidth: $ ? O : void 0
        }, n);
      })
    })
  }, s)), G = a.getAppSettings().maxWidth, j = X(G) ? "4px" : "16px";
  return /* @__PURE__ */ i(Z.Provider, {
    value: C.background,
    children: /* @__PURE__ */ _(rt, {
      $style: C,
      $paddingWidth: j,
      children: [/* @__PURE__ */ i(dt, {
        ref: d,
        $autoHeight: u,
        children: /* @__PURE__ */ i(q, {
          style: {
            height: u ? "auto" : "100%",
            margin: "0px",
            padding: "0px"
          },
          hideScrollbar: !D,
          children: /* @__PURE__ */ i(J, {
            onResize: (s, g) => {
              g && y(g);
            },
            observerOptions: {
              box: "border-box"
            },
            render: () => /* @__PURE__ */ i(lt, {
              $isHorizontal: $,
              $isGrid: h > 1,
              $autoHeight: u,
              children: F
            })
          })
        })
      }), /* @__PURE__ */ i(st, {
        children: /* @__PURE__ */ i(K, {
          size: "small",
          itemRender: Q,
          ...r.pagination
        })
      })]
    })
  });
}
export {
  wt as ListView
};
