import { X as r, Y as a, Z as x, $ as h, w as d, L as P, a0 as V, a1 as S, a2 as v, a3 as s, a4 as $, O as z, a5 as E, U as B, F as o, a6 as i, G as D, a7 as l, a8 as c, a9 as k, aa as L, ab as I, ac as A, ad as M, ae as N, af as T, ag as j, ah as O, ai as U, aj as F } from "./27705007.js";
import { useContext as b } from "react";
import { badgeChildren as R, BadgeBasicSection as W } from "./f5415341.js";
import "react-dom";
const q = r(M)`
  background: ${(e) => e.$style.background};
  color: ${(e) => e.$style.fill};
  cursor: ${(e) => e.$cursorPointer ? "pointer" : ""};
`, H = r.div`
display: flex;
width: 100%;
height: 100%;
padding: 0px;
align-items: center;
flex-direction: ${(e) => e.labelPosition === "left" ? "row" : "row-reverse"};
`, G = r.div`
width: calc(100% - ${(e) => e.iconSize}px);
display: flex;
padding-left: 5px;
padding-right: 5px;
flex-direction: column;
justify-content: flex-end;
align-items: ${(e) => e.alignmentPosition === "left" ? "flex-start" : "flex-end"};
`, X = r.span`
max-width: 100%;
overflow: hidden;
text-overflow: ellipsis;
white-space: nowrap;
font-weight: bold;
color: ${(e) => e.color};
`, Y = r.span`
max-width: 100%;
overflow: hidden;
text-overflow: ellipsis;
white-space: nowrap;
color: ${(e) => e.color};
`, Z = [N], J = [{
  label: a("avatarComp.square"),
  value: "square"
}, {
  label: a("avatarComp.circle"),
  value: "circle"
}], K = [{
  label: a("labelProp.left"),
  value: "left"
}, {
  label: a("labelProp.right"),
  value: "right"
}], Q = {
  style: x(h),
  icon: d(P, "/icon:solid/user"),
  iconSize: d(V, 40),
  onEvent: S(Z),
  shape: v(J, "circle"),
  title: s("title", ""),
  src: s("src", ""),
  avatarLabel: s("avatarLabel", "{{currentUser.name}}"),
  avatarCatption: s("avatarCatption", "{{currentUser.email}}"),
  labelPosition: v(K, "left"),
  alignmentPosition: d($, "left"),
  enableDropdownMenu: z,
  options: E,
  ...R
}, _ = (e) => {
  const {
    shape: u,
    title: m,
    src: C,
    iconSize: w
  } = e;
  b(T).getUICompByName(b(j));
  const f = e.options.findIndex((t) => {
    var n;
    return (n = t.prefixIcon) == null ? void 0 : n.props.value;
  }) > -1, p = e.options.filter((t) => !t.hidden).map((t, n) => ({
    title: t.label,
    label: t.label,
    key: t.label + " - " + n,
    disabled: t.disabled,
    icon: f && /* @__PURE__ */ o("span", {
      children: t.prefixIcon
    }),
    onEvent: t.onEvent
  })), g = /* @__PURE__ */ o(F, {
    items: p,
    onClick: ({
      key: t
    }) => {
      var n;
      return (n = p.find((y) => y.key === t)) == null ? void 0 : n.onEvent("click");
    }
  });
  return /* @__PURE__ */ o(O, {
    menu: {
      items: p
    },
    placement: e.labelPosition === "left" ? "bottomLeft" : "bottomRight",
    arrow: !0,
    disabled: !e.enableDropdownMenu,
    dropdownRender: () => g,
    children: /* @__PURE__ */ i(H, {
      iconSize: e.iconSize,
      labelPosition: e.labelPosition,
      children: [/* @__PURE__ */ o(U, {
        count: e.badgeCount.value,
        dot: e.badgeType === "dot",
        size: e.badgeSize,
        overflowCount: e.overflowCount,
        title: e.badgeTitle,
        offset: e.shape === "circle" ? [-2, 6] : [0, 0],
        children: /* @__PURE__ */ o(q, {
          size: w,
          icon: m.value !== "" ? null : e.icon,
          shape: u,
          $style: e.style,
          src: C.value,
          onClick: () => e.onEvent("click"),
          children: m.value
        })
      }), /* @__PURE__ */ i(G, {
        iconSize: e.iconSize,
        alignmentPosition: e.alignmentPosition,
        children: [/* @__PURE__ */ o(X, {
          color: e.style.label,
          children: e.avatarLabel.value
        }), /* @__PURE__ */ o(Y, {
          color: e.style.caption,
          children: e.avatarCatption.value
        })]
      })]
    })
  });
};
let ee = function() {
  return new B(Q, (e) => /* @__PURE__ */ o(_, {
    ...e
  })).setPropertyViewFn((e) => /* @__PURE__ */ i(D, {
    children: [/* @__PURE__ */ i(l, {
      name: c.basic,
      children: [e.src.propertyView({
        label: a("avatarComp.src"),
        placeholder: "http://xxxx/xx.jpg",
        tooltip: a("avatarComp.avatarCompTooltip")
      }), e.title.propertyView({
        label: a("avatarComp.title"),
        tooltip: a("avatarComp.avatarCompTooltip")
      }), e.icon.propertyView({
        label: a("avatarComp.icon"),
        IconType: "All",
        tooltip: a("avatarComp.avatarCompTooltip")
      }), e.shape.propertyView({
        label: a("avatarComp.shape"),
        radioButton: !0
      }), e.iconSize.propertyView({
        label: a("avatarComp.iconSize")
      }), e.enableDropdownMenu.propertyView({
        label: a("avatarComp.enableDropDown")
      }), e.enableDropdownMenu.getView() && e.options.propertyView({})]
    }), /* @__PURE__ */ i(l, {
      name: a("avatarComp.label"),
      children: [e.avatarLabel.propertyView({
        label: a("avatarComp.label")
      }), e.avatarCatption.propertyView({
        label: a("avatarComp.caption")
      }), e.labelPosition.propertyView({
        label: a("avatarComp.labelPosition"),
        radioButton: !0
      }), e.alignmentPosition.propertyView({
        label: a("avatarComp.alignmentPosition"),
        radioButton: !0
      })]
    }), /* @__PURE__ */ o(W, {
      ...e
    }), /* @__PURE__ */ o(l, {
      name: c.interaction,
      children: e.onEvent.getPropertyView()
    }), /* @__PURE__ */ o(l, {
      name: c.layout,
      children: k(e)
    }), /* @__PURE__ */ o(l, {
      name: c.style,
      children: e.style.getPropertyView()
    })]
  })).build();
}();
const le = L(ee, [I, new A("badgeCount", a("button.textDesc"))]);
export {
  le as AvatarComp
};
