import { X as h, af as j, de as E, F as n, eM as M, hy as X, hz as q, a6 as l, hA as w, G as x, df as m, dg as $, dh as u, hB as H, dn as O, at as D, dm as R } from "./27705007.js";
import { useContext as J, useRef as K, useEffect as Q } from "react";
import "react-dom";
const {
  Header: Y,
  Content: W,
  Footer: Z,
  Sider: P
} = w, A = h.div`
  width: 100%;
  top: 0;
  max-width: inherit;
  overflow: auto;
  height: 100%;
`, _ = (a) => D`
    border-color: ${a.border};
    border-width: ${a.borderWidth};
    border-radius: ${a.radius};
    overflow: hidden;
    padding: ${a.padding};
    ${a.background && `background-color: ${a.background};`}
    ${a.backgroundImage && `background-image: ${a.backgroundImage};`}
    ${a.backgroundImageRepeat && `background-repeat: ${a.backgroundImageRepeat};`}
    ${a.backgroundImageSize && `background-size: ${a.backgroundImageSize};`}
    ${a.backgroundImagePosition && `background-position: ${a.backgroundImagePosition};`}
    ${a.backgroundImageOrigin && `background-origin: ${a.backgroundImageOrigin};`}
  `, S = h.div`
  display: flex;
  flex-flow: column;
  height: 100%;
  border: 1px solid #d7d9e0;
  border-radius: 4px;
  ${(a) => a.$style && _(a.$style)}
`, y = h(R)`
  overflow: visible;
  ${(a) => a.$backgroundColor && `background-color: ${a.$backgroundColor};`}
  border-radius: 0;
  ${(a) => a.$headerBackgroundImage && `background-image: ${a.$headerBackgroundImage};`}
  ${(a) => a.$headerBackgroundImageRepeat && `background-repeat: ${a.$headerBackgroundImageRepeat};`}
  ${(a) => a.$headerBackgroundImageSize && `background-size: ${a.$headerBackgroundImageSize};`}
  ${(a) => a.$headerBackgroundImagePosition && `background-position: ${a.$headerBackgroundImagePosition};`}
  ${(a) => a.$headerBackgroundImageOrigin && `background-origin: ${a.$headerBackgroundImageOrigin};`}
`, C = h(R)`
  overflow: auto;
  ${(a) => a.$backgroundColor && `background-color: ${a.$backgroundColor};`}
  border-radius: 0;
  ${(a) => a.$siderBackgroundImage && `background-image: ${a.$siderBackgroundImage};`}
  ${(a) => a.$siderBackgroundImageRepeat && `background-repeat: ${a.$siderBackgroundImageRepeat};`}
  ${(a) => a.$siderBackgroundImageSize && `background-size: ${a.$siderBackgroundImageSize};`}
  ${(a) => a.$siderBackgroundImagePosition && `background-position: ${a.$siderBackgroundImagePosition};`}
  ${(a) => a.$siderBackgroundImageOrigin && `background-origin: ${a.$siderBackgroundImageOrigin};`}
`, F = h(R)`
  border-top: ${(a) => `${a.$showBorder ? a.$borderWidth : 0} solid ${a.$borderColor}`};
  flex: 1;
  ${(a) => a.$backgroundColor && `background-color: ${a.$backgroundColor};`}
  border-radius: 0;
  ${(a) => a.$backgroundImage && `background-image: ${a.$backgroundImage};`}
  ${(a) => a.$backgroundImageRepeat && `background-repeat: ${a.$backgroundImageRepeat};`}
  ${(a) => a.$backgroundImageSize && `background-size: ${a.$backgroundImageSize};`}
  ${(a) => a.$backgroundImagePosition && `background-position: ${a.$backgroundImagePosition};`}
  ${(a) => a.$backgroundImageOrigin && `background-origin: ${a.$backgroundImageOrigin};`}
`, aa = h(R)`
  border-top: ${(a) => `${a.$showBorder ? a.$borderWidth : 0} solid ${a.$borderColor}`};
  overflow: visible;
  ${(a) => a.$backgroundColor && `background-color: ${a.$backgroundColor};`}
  border-radius: 0;
  ${(a) => a.$footerBackgroundImage && `background-image: ${a.$footerBackgroundImage};`}
  ${(a) => a.$footerBackgroundImageRepeat && `background-repeat: ${a.$footerBackgroundImageRepeat};`}
  ${(a) => a.$footerBackgroundImageSize && `background-size: ${a.$footerBackgroundImageSize};`}
  ${(a) => a.$footerBackgroundImagePosition && `background-position: ${a.$footerBackgroundImagePosition};`}
  ${(a) => a.$footerBackgroundImageOrigin && `background-origin: ${a.$footerBackgroundImageOrigin};`}
`;
function da(a) {
  const {
    container: o,
    siderCollapsed: p,
    setSiderCollapsed: I
  } = a, {
    showHeader: t,
    showFooter: s,
    showSider: k
  } = o, {
    items: G,
    ...N
  } = o.header, {
    items: f,
    ...v
  } = o.body[0].children.view.getView(), {
    items: L,
    ...U
  } = o.footer, {
    items: b,
    ...B
  } = o.sider, {
    style: d,
    headerStyle: i,
    siderStyle: r,
    bodyStyle: e,
    footerStyle: g
  } = o, T = J(j).getAppSettings().maxWidth;
  E(T);
  const z = K();
  function V(c) {
    a.setSiderCollapsed(c);
  }
  return Q(() => {
    I(o.siderCollapsed);
  }, [o.siderCollapsed]), /* @__PURE__ */ n("div", {
    style: {
      padding: d.margin,
      height: "100%"
    },
    children: /* @__PURE__ */ n(M, {
      theme: {
        components: {
          Layout: {
            triggerBg: X(o.siderStyle.siderBackground),
            triggerColor: q(o.siderStyle.siderBackground, "black", "white"),
            siderBg: o.siderStyle.siderBackground
          }
        }
      },
      children: /* @__PURE__ */ l(S, {
        $style: d,
        children: [/* @__PURE__ */ l(w, {
          style: {
            padding: "0px"
          },
          hasSider: k && !o.innerSider,
          children: [k && !o.innerSider && !o.siderRight && /* @__PURE__ */ n(x, {
            children: /* @__PURE__ */ n(m.Provider, {
              value: r == null ? void 0 : r.siderBackground,
              children: /* @__PURE__ */ n(P, {
                width: o.siderWidth,
                style: {
                  padding: "0px",
                  margin: "0px",
                  backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                },
                collapsible: o.siderCollapsible,
                breakpoint: "sm",
                collapsedWidth: o.siderCollapsedWidth,
                collapsed: p,
                onCollapse: (c) => V(c),
                children: /* @__PURE__ */ n($, {
                  style: {
                    height: o.autoHeight ? "auto" : "100%",
                    margin: "0px",
                    padding: "0px"
                  },
                  hideScrollbar: !o.siderScrollbars,
                  children: /* @__PURE__ */ n(C, {
                    ...B,
                    items: u(b),
                    autoHeight: !0,
                    emptyRows: 30,
                    minHeight: `calc(100vh - ${d.padding}px)`,
                    containerPadding: [0, 0],
                    showName: {
                      bottom: s ? 20 : 0
                    },
                    $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                    $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                    $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                    $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                    $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                    $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                    style: {
                      padding: r.containerSiderPadding
                    }
                  })
                })
              })
            })
          }), /* @__PURE__ */ l(w, {
            style: {
              padding: "0px"
            },
            children: [t && /* @__PURE__ */ n(x, {
              children: /* @__PURE__ */ n(m.Provider, {
                value: d.background,
                children: /* @__PURE__ */ n(Y, {
                  style: {
                    backgroundColor: (i == null ? void 0 : i.headerBackground) || "transparent",
                    padding: "0px",
                    margin: "0px"
                  },
                  children: /* @__PURE__ */ n(y, {
                    ...N,
                    items: u(G),
                    autoHeight: !0,
                    emptyRows: 5,
                    minHeight: "46px",
                    containerPadding: [0, 0],
                    showName: {
                      bottom: s ? 20 : 0
                    },
                    $backgroundColor: (i == null ? void 0 : i.headerBackground) || "transparent",
                    $headerBackgroundImage: i == null ? void 0 : i.headerBackgroundImage,
                    $headerBackgroundImageRepeat: i == null ? void 0 : i.headerBackgroundImageRepeat,
                    $headerBackgroundImageSize: i == null ? void 0 : i.headerBackgroundImageSize,
                    $headerBackgroundImagePosition: i == null ? void 0 : i.headerBackgroundImagePosition,
                    $headerBackgroundImageOrigin: i == null ? void 0 : i.headerBackgroundImageOrigin,
                    style: {
                      padding: i.containerHeaderPadding
                    }
                  })
                })
              })
            }), k && o.innerSider ? /* @__PURE__ */ n(x, {
              children: /* @__PURE__ */ l(w, {
                style: {
                  padding: "0px"
                },
                hasSider: k && o.innerSider,
                children: [k && !o.siderRight && /* @__PURE__ */ n(m.Provider, {
                  value: r == null ? void 0 : r.siderBackground,
                  children: /* @__PURE__ */ n(P, {
                    width: o.siderWidth,
                    style: {
                      padding: "0px",
                      margin: "0px",
                      marginTop: d.borderWidth,
                      backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                    },
                    collapsible: o.siderCollapsible,
                    breakpoint: "sm",
                    collapsedWidth: o.siderCollapsedWidth,
                    collapsed: p,
                    onCollapse: (c) => I(c),
                    children: /* @__PURE__ */ n($, {
                      style: {
                        height: o.autoHeight ? "auto" : "100%",
                        margin: "0px",
                        padding: "0px"
                      },
                      hideScrollbar: !o.siderScrollbars,
                      children: /* @__PURE__ */ n(C, {
                        ...B,
                        items: u(b),
                        autoHeight: !0,
                        emptyRows: 30,
                        minHeight: `calc(100vh - ${d.padding}px)`,
                        containerPadding: [0, 0],
                        showName: {
                          bottom: s ? 20 : 0
                        },
                        $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                        $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                        $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                        $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                        $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                        $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                        style: {
                          padding: r.containerSiderPadding
                        }
                      })
                    })
                  })
                }), /* @__PURE__ */ n(W, {
                  style: {
                    padding: "0px",
                    margin: "0px",
                    backgroundColor: (e == null ? void 0 : e.background) || "transparent"
                  },
                  children: /* @__PURE__ */ n($, {
                    style: {
                      height: o.autoHeight ? "auto" : "100%",
                      margin: "0px",
                      padding: "0px"
                    },
                    hideScrollbar: !o.contentScrollbars,
                    children: o.showApp && o.contentApp != "" ? /* @__PURE__ */ n(m.Provider, {
                      value: e == null ? void 0 : e.background,
                      children: /* @__PURE__ */ n(A, {
                        children: /* @__PURE__ */ n(H, {
                          ref: z,
                          appId: o.contentApp,
                          baseUrl: o.baseUrl
                        })
                      })
                    }) : /* @__PURE__ */ n(F, {
                      $showBorder: t,
                      ...v,
                      items: u(f),
                      autoHeight: o.autoHeight,
                      emptyRows: 14,
                      minHeight: t ? "143px" : "142px",
                      containerPadding: [0, 0],
                      hintPlaceholder: a.hintPlaceholder ?? O,
                      $backgroundColor: (e == null ? void 0 : e.background) || "transparent",
                      $borderColor: d == null ? void 0 : d.border,
                      $borderWidth: d == null ? void 0 : d.borderWidth,
                      $backgroundImage: e == null ? void 0 : e.backgroundImage,
                      $backgroundImageRepeat: e == null ? void 0 : e.backgroundImageRepeat,
                      $backgroundImageSize: e == null ? void 0 : e.backgroundImageSize,
                      $backgroundImagePosition: e == null ? void 0 : e.backgroundImagePosition,
                      $backgroundImageOrigin: e == null ? void 0 : e.backgroundImageOrigin,
                      style: {
                        padding: e.containerBodyPadding
                      }
                    })
                  })
                }), k && o.siderRight && /* @__PURE__ */ n(m.Provider, {
                  value: r == null ? void 0 : r.siderBackground,
                  children: /* @__PURE__ */ n(P, {
                    width: o.siderWidth,
                    style: {
                      padding: "0px",
                      margin: "0px",
                      backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                    },
                    collapsible: o.siderCollapsible,
                    breakpoint: "sm",
                    collapsedWidth: o.siderCollapsedWidth,
                    reverseArrow: !0,
                    collapsed: p,
                    onCollapse: (c) => I(c),
                    children: /* @__PURE__ */ n($, {
                      style: {
                        height: o.autoHeight ? "auto" : "100%",
                        margin: "0px",
                        padding: "0px"
                      },
                      hideScrollbar: !o.siderScrollbars,
                      children: /* @__PURE__ */ n(C, {
                        ...B,
                        items: u(b),
                        autoHeight: !0,
                        emptyRows: 30,
                        minHeight: `calc(100vh - ${d.padding}px)`,
                        containerPadding: [0, 0],
                        showName: {
                          bottom: s ? 20 : 0
                        },
                        $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                        $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                        $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                        $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                        $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                        $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                        style: {
                          padding: r.containerSiderPadding
                        }
                      })
                    })
                  })
                })]
              })
            }) : /* @__PURE__ */ n(W, {
              style: {
                padding: "0px",
                margin: "0px"
              },
              children: /* @__PURE__ */ n($, {
                style: {
                  height: o.autoHeight ? "auto" : "100%",
                  margin: "0px",
                  padding: "0px"
                },
                hideScrollbar: !o.contentScrollbars,
                children: o.showApp && o.contentApp != "" ? /* @__PURE__ */ n(m.Provider, {
                  value: e == null ? void 0 : e.background,
                  children: /* @__PURE__ */ n(A, {
                    children: /* @__PURE__ */ n(H, {
                      ref: z,
                      appId: o.contentApp,
                      baseUrl: o.baseUrl
                    })
                  })
                }) : /* @__PURE__ */ n(F, {
                  $showBorder: t,
                  ...v,
                  items: u(f),
                  autoHeight: o.autoHeight,
                  emptyRows: 14,
                  minHeight: t ? "143px" : "142px",
                  containerPadding: [0, 0],
                  hintPlaceholder: a.hintPlaceholder ?? O,
                  $backgroundColor: (e == null ? void 0 : e.background) || "transparent",
                  $borderColor: d == null ? void 0 : d.border,
                  $borderWidth: d == null ? void 0 : d.borderWidth,
                  $backgroundImage: e == null ? void 0 : e.backgroundImage,
                  $backgroundImageRepeat: e == null ? void 0 : e.backgroundImageRepeat,
                  $backgroundImageSize: e == null ? void 0 : e.backgroundImageSize,
                  $backgroundImagePosition: e == null ? void 0 : e.backgroundImagePosition,
                  $backgroundImageOrigin: e == null ? void 0 : e.backgroundImageOrigin,
                  style: {
                    padding: e.containerBodyPadding
                  }
                })
              })
            }), s && /* @__PURE__ */ n(Z, {
              style: {
                textAlign: "center",
                padding: "0px",
                margin: "0px",
                backgroundColor: (g == null ? void 0 : g.footerBackground) || "transparent"
              },
              children: /* @__PURE__ */ n(aa, {
                $showBorder: t,
                ...U,
                items: u(L),
                autoHeight: !0,
                emptyRows: 5,
                minHeight: "48px",
                containerPadding: [0, 0],
                showName: {
                  top: t ? 20 : 0
                },
                $backgroundColor: (g == null ? void 0 : g.footerBackground) || "transparent",
                $footerBackgroundImage: g == null ? void 0 : g.footerBackgroundImage,
                $footerBackgroundImageRepeat: g == null ? void 0 : g.footerBackgroundImageRepeat,
                $footerBackgroundImageSize: g == null ? void 0 : g.footerBackgroundImageSize,
                $footerBackgroundImagePosition: g == null ? void 0 : g.footerBackgroundImagePosition,
                $footerBackgroundImageOrigin: g == null ? void 0 : g.footerBackgroundImageOrigin,
                $borderColor: d == null ? void 0 : d.border,
                $borderWidth: d == null ? void 0 : d.borderWidth,
                style: {
                  padding: g.containerFooterPadding
                }
              })
            })]
          }), k && !o.innerSider && o.siderRight && /* @__PURE__ */ n(x, {
            children: /* @__PURE__ */ n(m.Provider, {
              value: r == null ? void 0 : r.siderBackground,
              children: /* @__PURE__ */ n(P, {
                width: o.siderWidth,
                style: {
                  padding: "0px",
                  margin: "0px",
                  backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent"
                },
                collapsible: o.siderCollapsible,
                breakpoint: "sm",
                collapsedWidth: o.siderCollapsedWidth,
                reverseArrow: !0,
                collapsed: p,
                onCollapse: (c) => I(c),
                children: /* @__PURE__ */ n($, {
                  style: {
                    height: o.autoHeight ? "auto" : "100%",
                    margin: "0px",
                    padding: "0px"
                  },
                  hideScrollbar: !o.siderScrollbars,
                  children: /* @__PURE__ */ n(C, {
                    ...B,
                    items: u(b),
                    autoHeight: !0,
                    emptyRows: 30,
                    minHeight: `calc(100vh - ${d.padding}px)`,
                    containerPadding: [0, 0],
                    showName: {
                      bottom: s ? 20 : 0
                    },
                    $backgroundColor: (r == null ? void 0 : r.siderBackground) || "transparent",
                    $siderBackgroundImage: r == null ? void 0 : r.siderBackgroundImage,
                    $siderBackgroundImageRepeat: r == null ? void 0 : r.siderBackgroundImageRepeat,
                    $siderBackgroundImageSize: r == null ? void 0 : r.siderBackgroundImageSize,
                    $siderBackgroundImagePosition: r == null ? void 0 : r.siderBackgroundImagePosition,
                    $siderBackgroundImageOrigin: r == null ? void 0 : r.siderBackgroundImageOrigin,
                    style: {
                      padding: r.containerSiderPadding
                    }
                  })
                })
              })
            })
          })]
        }), /* @__PURE__ */ n("style", {
          children: `
              .ant-layout-sider-trigger {
                bottom: 4px !important;
                ${o.siderRight ? `
                  right: 8px !important;
                ` : `
                  left: 8px !important;}
                `}
                
              }
            `
        })]
      })
    })
  });
}
export {
  da as PageLayout
};
